;/*====================================================*/
;/*  stdlib.inc     version 0.07             ::  */
;/*                                                    */
;/*  Copyright (C) 1990  -  All Rights Reserved.       */
;/*  Software Satisfaction.                            */
;/*  J.P.N.                                            */
;/*                                                    */
;/*  for Macro Assembler version 5.10                  */
;/*                                                    */
;/*  Author: Seiji Yasuda                              */
;/*                                                    */
;/*                                                    */
;/*  B...byte type.         W...word type.             */
;/*  M...memory.            S...segment regs.(CS)      */
;/*  X...no segment regs.   C...code                   */
;/*                                                    */
;/*====================================================*/




;-------------------------------------
; $push	<WXS,,,,,>
;
$push	macro	_$regs
		irp		reg,<_$regs>
		push	reg
		endm
		endm

;-------------------------------------
; $pop <WXS,,,,,>
;
$pop	macro	_$regs
		irp		reg,<_$regs>
		pop		reg
		endm
		endm

;-------------------------------------
; $exit BXC
;
$exit	macro	_$cd
		mov		al, _$cd
		mov		ah, 4ch
		int		21h
		endm


;-------------------------------------
; $keep WC
;
$keep	macro	_$endoff
		mov		ax, 3100h
		mov		dx, _$endoff
		mov		cl, 4
		shr		dx, cl
		inc		dx
		int		21h
		endm

;-------------------------------------
; $mov  WXSMC, WXSMC
;
$mov	macro	_$reg1, _$reg2
		push	_$reg2
		pop		_$reg1
		endm

;-------------------------------------
; $free WXC
$free	macro	_$psp
		push	es
		mov		es, _$psp
		push	es
		mov		es, es:[2CH]
		mov		ah, 49H
		int		21H
		pop		es
		mov		ah, 49H
		int		21H
		pop		bx
		endm

;-------------------------------------
; $setvec	BC, WCS, WC
;
$setvec	macro	_$vecno, _$seg, _$off
		$push	<bx,ds>
		xor		ax, ax
		mov		ds, ax
		mov		bx, _$vecno * 4
		cli
		mov		ax, _$off
		mov		ds:[bx+0], ax
		mov		ax, _$seg
		mov		ds:[bx+2], ax
		sti
		$pop	<ds,bx>
		endm

;-------------------------------------
; $setvec	BC	ret( ax:seg, bx:off )
;
$getvec	macro	_$vecno
		push	ds
		xor		ax, ax
		mov		ds, ax
		mov		bx, _$vecno * 4
		cli
		mov		ax, ds:[bx+0]
		mov		bx, ds:[bx+2]
		sti
		pop		ds
		endm


;-----------------------------------------
; $McbSer	WC	ret(ax:seg,,0:not found)
; 
$McbSer	macro	_$str
		local	McbSer1, McbSer2
		local	McbSer3, break_McbSer
		$push	<bx,cx,si,di,es>
		mov		ah, 52h
		int		21h
		sub		bx, 2
		mov		ax, es:[bx]
McbSer1:
		mov		es, ax
		cld
		mov		si, _$str
		mov		di, _$str + 16
		mov		cx, 16
		repe	cmpsb
		jne		McbSer2
		jmp		short break_McbSer
McbSer2:
		cmp		byte ptr es:[0], 'Z'
		jne		McbSer3
		xor		ax, ax
		jmp		short break_McbSer
McbSer3:
		mov		ax, es
		inc		ax
		add		ax, word ptr es:[3]
		jmp		short McbSer1
break_McbSer:
		$pop	<es,di,si,cx,bx>
		endm



