

		.386p			;386ی샂[h


seg_graph1	equ	0120h		;vram access mode 1 (32Kcolors)
seg_graph2	equ	0128h		;vram access mode 2 (256colors)
seg_sprite0	equ	0130h		;XvCg
seg_jisho	equ	0138h		;ROM
seg_sound	equ	0140h		;g`ZOg
seg_osrom	equ	0148h		;

seg_low1m	equ	0034h		;
seg_sprite	equ	0114h		;XvCg

I8259_M		equ	0000h		;master i/o adr.   (int 40h-47h)
I8259_S		equ	0010h		;slave  i/o adr.   (int 48h-4Fh)
ISR_READ	equ	0Bh		;command
EOI		equ	20h		;command (End Of Interrupt)

INT_MASK_V	equ	00001000b
INT_VECT_V	equ	4Bh		;v-sync vector number
V_INT_CLR	equ	05CAh

CODE		segment	dword public ER use32 'CODE'
		assume	cs:CODE

		public	prog_end

		extrn	palette_data:near
		extrn	prog_start:near
		extrn	int_f:byte
		extrn	obj_jiki:near
		extrn	obj_jiki2:near

		org	0000h
start:		cld
		jmp	tobasi

	db	'  Copyright 1991 H.Udagawa All Rights Reserved. '
	db	'̃vO̒쌠͂oddOOVQT@'
	db	'g`k@Ɓ@Fc vۗLĂ܂B@'
	db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

tobasi:

;---------------------------------------Ƒ҂Ă܂
;      fBXÑANZXv܂š
		mov	ax,100
waitv:		mov	cx,0FFF0h
waith:		loop	waith
		dec	ax
		jne	waitv
;---------------------------------------

;--------@tbv
		mov	esi,offset obj_jiki
		mov	edi,offset obj_jiki2
		mov	dl,8
v_loop:		mov	ebx,15
h_flip:		mov	al,ds:[esi+ebx]
		mov	ds:[edi],al
		inc	edi
		dec	ebx
		jns	h_flip
		add	esi,10h
		dec	dl
		jne	v_loop

;---------------------------------------------------------------
;		xN^̓o^
;---------------------------------------------------------------
		cli
		push	ds
		mov	ax,cs
		mov	ds,ax
		mov	cl,INT_VECT_V	;v-sync vector number
		lea	edx,vect_v_entry
		mov	ax,2506h
		int	21h
		pop	ds

;---------------------------------------------------------------
;		^C}[݃}XN
;---------------------------------------------------------------
		in	al,I8259_M+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		or	al,00000001b
		out	I8259_M+2,al

;---------------------------------------------------------------
;		݃Cl[u
;---------------------------------------------------------------
		in	al,I8259_S+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		mov	dl,INT_MASK_V
		xor	dl,0FFh
		and	al,dl
		or	al,00100000b	;opm int mask
		out	I8259_S+2,al

		sti
;***********************************************
		push	0034h	;LOW 1MB
		pop	gs
		call	set_pri
		call	set_crt
		push	0128h
		pop	gs

;*********************************************** OtBbNNA
		call	gcls
		call	set_palette

		jmp	prog_start

gcls:		mov	edi,0
cls_loop:	mov	dword ptr gs:[edi*4],00000000h
		inc	edi
		cmp	edi,20000h
		jne	cls_loop
		ret

prog_end:	cli
;---------------------------------------------------------------
;		^C}[݃}XN
;---------------------------------------------------------------
		in	al,I8259_M+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		and	al,11111110b
		out	I8259_M+2,al

;---------------------------------------------------------------
;		݃Cl[u
;---------------------------------------------------------------
		in	al,I8259_S+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		mov	dl,INT_MASK_V
		or	al,dl
		and	al,11011111b	;opm int mask
		out	I8259_S+2,al

		sti

		call	gcls
		mov	ax,4C00h
		int	21h


set_palette:	mov	esi,offset palette_data
		mov	bl,0		;palette no.

setp_loop:	mov	dx,0FD90h
		mov	al,bl
		out	dx,al		;set palette no.

		lodsb
		mov	dx,0FD94h	;set red
		out	dx,al

		lodsb
		mov	dx,0FD96h	;set green
		out	dx,al

		lodsb
		mov	dx,0FD92h	;set blue
		out	dx,al

		inc	bl
		jne	setp_loop
		ret


;***********************************************
set_crt:	mov	esi,offset crtc
		mov	bl,00h
setlp:		mov	dx,0440h	;register select
		mov	al,bl
		out	dx,al
		mov	dx,0442h	;data set
		lodsw
		out	dx,ax
		inc	bl
		cmp	bl,20h
		jb	setlp
		ret

crtc		dw	0086h	;00 HSW1	;M
		dw	0610h	;01 HSW2
		dw	0000h	;02 ---
		dw	0000h	;03 ---
		dw	071Bh	;04 HST
		dw	0006h	;05 VST
		dw	000Ch	;06 VST2
		dw	0012h	;07 EET
		dw	020Bh	;08 VST

		dw	01A0h	;09 HDS0	;̕\͈
		dw	06A0h	;10 HDE0
		dw	01A0h	;11 HDS1
		dw	06A0h	;12 HDE1

		dw	0054h	;13 VDS0	;c̕\͈
		dw	01E4h	;14 VDE0
		dw	0054h	;15 VDS1
		dw	01E4h	;16 VDE1

		dw	0000h	;17 FA0		;\ʒu
		dw	0020h	;18 HAJ0
		dw	0000h	;19 FO0
		dw	0080h	;20 LO0

		dw	0000h	;21 FA1		;\ʒu
		dw	0020h	;22 HAJ1
		dw	0000h	;23 FO1
		dw	0080h	;24 LO1

		dw	0064h	;25 EHAJ
		dw	0007h	;26 EVAJ
		dw	0303h	;27 ZOOM

		dw	800Fh	;28 CR0
		dw	000Ch	;29 CR1
		dw	0003h	;30 FR
		dw	01CAh	;31 CR2


set_pri:	mov	dx,0448h
		mov	al,0		;WX^0
		out	dx,al
		mov	dx,044Ah
		mov	al,0Ah
		out	dx,al

		mov	dx,0448h
		mov	al,1		;WX^1
		out	dx,al
		mov	dx,044Ah
		mov	al,18h
		out	dx,al
		ret


;---------------------------------------------------------------
;		C^vg[`
;---------------------------------------------------------------
vect_v_entry:	push	eax
		push	edx
		push	ds

		push	0014h
		pop	ds
;---------------------------------------
		mov	dx,V_INT_CLR
		mov	al,0
		out	dx,al		;v-sync v
;---------------------------------------
		inc	ds:int_f
;---------------------------------------
skip_int:	cli
		call	eoi_out

		pop	ds
		pop	edx
		pop	eax
		iretd

;---------------------------------------------------------------
;		C^vgRg[eoi𔭍s
;---------------------------------------------------------------
eoi_out:	mov	al,ISR_READ
		out	I8259_M,al
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		in	al,I8259_M
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		test	al,7Fh		;master ?
		jz	short eoi_slave

		mov	al,EOI
		out	I8259_M,al	;}X^[eoi𔭍s
		jmp	short eoi_exit

eoi_slave:	mov	al,EOI
		out	I8259_S,al	;Tueoi𔭍s
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2

		mov	al,ISR_READ
		out	I8259_S,al
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		in	al,I8259_S
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		or	al,al
		jnz	short eoi_exit

		mov	al,EOI
		out	I8259_M,al	;}X^[eoi𔭍s

eoi_exit:	jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		ret

CODE		ends

		end

