/*
    Wind Consol
*/
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    "defs.h"

void    KEY_up()
{
    if ( WIN_up_scrool(act_wind,1) != ERR )
        wind[act_wind].wrt_mode = 3;
}
void    KEY_down()
{
    if ( WIN_down_scrool(act_wind,1) != ERR )
        wind[act_wind].wrt_mode = 3;
}
void    KEY_uscr()
{
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;
    lp = get_lin(cp->now_ptr);
    if ( NEXT_ptr(act_wind,lp) == ERR )
        return;
    cp->now_ptr = NEXT_ptr(act_wind,lp);
    cp->lin_pos++;
    cp->wrt_mode = 3;
}
void    KEY_dscr()
{
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;
    lp = get_lin(cp->now_ptr);
    if ( lp->right == ERR )
        return;
    cp->now_ptr = lp->right;
    cp->lin_pos--;
    cp->wrt_mode = 3;
}
void    KEY_upage()
{
    if ( WIN_up_scrool(act_wind,10) != ERR )
        wind[act_wind].wrt_mode = 3;
}
void    KEY_dpage()
{
    if ( WIN_down_scrool(act_wind,10) != ERR )
        wind[act_wind].wrt_mode = 3;
}
void    KEY_left()
{
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p;

    cp = &(wind[act_wind]);

    if ( --cp->cur_x < 0 ) {
        KEY_up();
        if ( cp->now_ptr != ERR ) {
            lp = get_lin(cp->now_ptr);
            cp->cur_x = 0;
            for ( p = lp->lin ; *p != '\n' && *p != '\0' ; p++ )
                cp->cur_x++;
            if ( cp->cur_x >= 80 )
                cp->cur_x = 79;
        } else
            cp->cur_x = 79;

    } else if ( cp->now_ptr != ERR ) {
        lp = get_lin(cp->now_ptr);
        if ( cp->cur_x < strlen(lp->lin) )
            cp->cur_x = kan_pos(lp->lin,cp->cur_x);
    }
}
void    KEY_right()
{
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( ++cp->cur_x >= 80 ) {
        cp->cur_x = 0;
        KEY_down();
    } else if ( cp->now_ptr != ERR ) {
        lp = get_lin(cp->now_ptr);
        if ( cp->cur_x < strlen(lp->lin) &&
             cp->cur_x != kan_pos(lp->lin,cp->cur_x) )
            cp->cur_x++;
    }
}
void    KEY_tline()
{
    wind[act_wind].cur_x = 0;
}
void    KEY_bline()
{
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr != ERR ) {
        lp = get_lin(cp->now_ptr);
        cp->cur_x = 0;
        for ( p = lp->lin ; *p != '\n' && *p != '\0' ; p++ )
            cp->cur_x++;
        if ( cp->cur_x >= 80 )
            cp->cur_x = 79;
    } else
        cp->cur_x = 79;
}
void    KEY_wright()
{
    int     n,len,fg;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;

    lp = get_lin(cp->now_ptr);
    len = strlen(lp->lin);
    fg = (cp->cur_x >= len ? 1:0);

    for ( ; ; ) {
        while ( cp->cur_x >= len ) {
            if ( NEXT_ptr(act_wind,lp) == ERR )
                return;
            cp->cur_x = 0;
            if ( ++cp->cur_y >= cp->max_y ) {
                cp->cur_y = cp->max_y - 1;
                cp->wrt_mode = 3;
            }
            cp->now_ptr = NEXT_ptr(act_wind,lp);
            cp->lin_pos++;
            lp = get_lin(cp->now_ptr);
            len = strlen(lp->lin);
        }
        n = kan_pos(lp->lin,cp->cur_x);
        if ( fg == 0 && lp->lin[n] < '0' )
            fg = 1;
        if ( fg != 0 && lp->lin[n] >= '0' )
            break;
        cp->cur_x = n + (iskan(&(lp->lin[n])) ? 2:1);
    }
}
void    KEY_wleft()
{
    int     n,len,fg;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;

    lp = get_lin(cp->now_ptr);
    len = strlen(lp->lin);

    for ( fg = 0 ; ; ) {
        while ( cp->cur_x < 0 ) {
            cp->cur_x = 0;
            if ( lp->right == ERR )
                return;
            if ( cp->cur_y > 0 )
                cp->cur_y--;
            else
                cp->wrt_mode = 3;
            cp->now_ptr = lp->right;
            cp->lin_pos--;
            lp = get_lin(cp->now_ptr);
            len = strlen(lp->lin);
            cp->cur_x = len - 1;
        }
        n = kan_pos(lp->lin,cp->cur_x);
        if ( fg == 0 && lp->lin[n] < '0' )
            fg = 1;
        if ( fg == 1 && lp->lin[n] >= '0' )
            fg = 2;
        if ( fg == 2 && lp->lin[n] < '0' ) {
            if ( ++cp->cur_x >= len )
                KEY_wright();
            break;
        }
        cp->cur_x = n-1;
    }
}
void    KEY_tfile()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( (n = cp->now_ptr) == ERR )
        return;

    for ( ; ; ) {
        lp = get_lin(n);
        if ( lp->right == ERR )
            break;
        cp->lin_pos--;
        n = lp->right;
    }
    cp->now_ptr = n;
    cp->wrt_mode = 3;
    cp->cur_y = 0;
}
void    KEY_bfile()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( (n = cp->now_ptr) == ERR )
        return;

    for ( ; ; ) {
        lp = get_lin(n);
        if ( NEXT_ptr(act_wind,lp) == ERR )
            break;
        cp->lin_pos++;
        n = NEXT_ptr(act_wind,lp);
    }
    cp->now_ptr = n;
    cp->wrt_mode = 3;
    if ( cp->lin_max < cp->max_y )
        cp->cur_y = cp->lin_max;
    else
        cp->cur_y = cp->max_y - 1;
}
