#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    "defs.h"

int	disp_mode=0;
int	disp_col=7;

static int  cut_ptr=ERR;

void    PTR_ins(no,ptr)
int     no,ptr;
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;
    LIN_PTR *bp;

    cp = &(wind[no]);

    if ( cp->now_ptr == ERR ) {
        cp->now_ptr = xalloc();
        lp = get_lin(cp->now_ptr);
        lp->lin[0] = '\0';
	lp->new_flg = TRUE;
        cp->wrt_mode = 3;
        cp->lin_max = 1;
        cp->lin_pos = 0;
        cp->wrt_flg = TRUE;
    }

    while ( ptr != ERR ) {
        n = xalloc();
        tp = get_lin(n);
        bp = get_lin(ptr);
        strcpy(tp->lin,bp->lin);
	tp->new_flg = TRUE;
        ptr = bp->left;

        lp = get_lin(cp->now_ptr);
        if ( (tp->right = lp->right) != ERR ) {
            bp = get_lin(tp->right);
            bp->left = n;
        }
        lp->right = n;
        tp->left = cp->now_ptr;

        cp->wrt_mode = 3;
        cp->lin_max++;
        cp->lin_pos++;
        cp->wrt_flg = TRUE;
        if ( cp->cur_y < (cp->max_y - 2) )
            cp->cur_y++;
    }
}
void    KEY_paste()
{
    if ( cut_ptr != ERR )
        PTR_ins(act_wind,cut_ptr);
}
void    KEY_cut()
{
    int     i,j,n;
    int     ch,fg,rc;
    int     old_pos,sta_pos,end_pos;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;
    struct {
        int     sts_pos;
        char    sts_fg;
    } lin_sts[25];

    cp = &(wind[act_wind]);
    if ( cp->now_ptr == ERR )
        return;

    cursol(0);
    MSG_dsp("Cut & Paste Mode");

    old_pos = cp->lin_pos;

    for ( i = 0 ; i < 25 ; i++ )
        lin_sts[i].sts_pos = ERR;

    for ( ; ; ) {
 
        if ( old_pos < cp->lin_pos ) {
            sta_pos = old_pos;
            end_pos = cp->lin_pos;
        } else {
            sta_pos = cp->lin_pos;
            end_pos = old_pos;
        }

        n = cp->now_ptr;
        j = cp->lin_pos;
        for ( i = cp->cur_y ; i > 0 ; i-- ) {
            lp = get_lin(n);
            if ( lp->right == ERR )
                break;
            n = lp->right;
            j--;
        }
        for ( i = 0 ; i < cp->max_y ; i++ ) {
            if ( n != ERR ) {
                lp = get_lin(n);
                fg = ((sta_pos <= j && j <= end_pos ) ? TRUE:FALSE);
                if ( lin_sts[i].sts_pos != j || lin_sts[i].sts_fg != fg ) {

/*************************************************
                    if ( fg )
                        color(7,TRUE);
                    putstr(cp->wind_y+i,lp->lin);
		    color(7,FALSE);
***************************************************/

                    if ( fg ) {
                        disp_mode = 0x0800;
			disp_col = 6;
		    }
                    putstr(cp->wind_y+i,lp->lin);
                    disp_mode = 0;
		    disp_col = 7;

                    lin_sts[i].sts_pos = j;
                    lin_sts[i].sts_fg = fg;
                }
		lp->new_flg = TRUE;
                n = NEXT_ptr(act_wind,lp);
            } else {
                putstr(cp->wind_y+i,"");
                lin_sts[i].sts_pos = ERR;
            }
            j++;
        }
        WIN_stat(act_wind);

        do {
            ch = getch();
            switch(ch) {
            case 0x0D: rc = TRUE; goto ENDOF;
            case 0x1B: rc = FALSE; goto ENDOF;
            case 0x08: rc = ERR; goto ENDOF;

            case 0x1E: KEY_up(); break;
            case 0x1F: KEY_down(); break;
            case 'E'-'@': KEY_up(); break;
            case 'X'-'@': KEY_down(); break;
            case 'Z'-'@': KEY_uscr(); break;
            case 'W'-'@': KEY_dscr(); break;
            case 'R'-'@': KEY_upage(); break;
            case 'C'-'@': KEY_dpage(); break;
            case 0x1100+'R'-'@': KEY_tfile(); break;
            case 0x1100+'C'-'@': KEY_bfile(); break;
            }
        } while ( kbhit() );
    }

ENDOF:
    if ( rc != FALSE ) {
        n = cut_ptr;
        while ( n != ERR ) {
            lp = get_lin(n);
            i = lp->left;
            xfree(n);
            n = i;
        }

        if ( cp->lin_pos  > sta_pos )
            WIN_up_scrool(act_wind,cp->lin_pos - sta_pos);
        else
            WIN_down_scrool(act_wind,sta_pos - cp->lin_pos);

        i = ERR;
        j = cp->now_ptr;
        while ( j != ERR && sta_pos <= end_pos ) {
            n = xalloc();
            tp = get_lin(n);
            lp = get_lin(j);
            strcpy(tp->lin,lp->lin);
            j = NEXT_ptr(act_wind,lp);
            tp->right = i;
            tp->left = ERR;
            if ( i != ERR ) {
                lp = get_lin(i);
                lp->left = n;
            } else
                cut_ptr = n;
            i = n;
            sta_pos++;
            if ( rc == ERR )
                DEL_line();
        }
    }
    cp->wrt_mode = 3;
    MSG_dsp("");
}
