#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    "defs.h"

void    KEY_cr();
void    KEY_tab();
void    KEY_bs();
void    INS_line();
void    KEY_up();
void    KEY_down();
void    KEY_uscr();
void    KEY_dscr();
void    KEY_upage();
void    KEY_dpage();
void    KEY_left();
void    KEY_right();
void    KEY_tline();
void    KEY_bline();
void    KEY_wright();
void    KEY_wleft();
void    DEL_line();
void    KEY_del();
void    KEY_ldel();
void    KEY_rdel();
void    KEY_undo();
void    KEY_tfile();
void    KEY_bfile();
void    KEY_ins_sw();
void    KEY_serch();
void    KEY_paste();
void    KEY_cut();
void    WIN_save();
void    CMD_sub1();
void	MAC_save();
void	MAC_go();

void    WIN_stat(no)
int     no;
{
    register WIN_PTR *cp;

    cp = &(wind[no]);

    if ( cp->wrt_flg != cp->dsp_wrt ) {
        cp->dsp_wrt = cp->wrt_flg;
	color(7-(no&3),no == act_wind ? TRUE:FALSE);
        locate(0,cp->wind_y-1);
        cputs(cp->wrt_flg == 0 ? "DISP":"EDIT");
	color(7,FALSE);
    }

    if ( cp->lin_pos != cp->dsp_pos ) {
        cp->dsp_pos = cp->lin_pos;
	color(7-(no&3),no == act_wind ? TRUE:FALSE);
        locate(75,cp->wind_y-1);
        cprintf("%05d",cp->lin_pos+1);
	color(7,FALSE);
    }
}
void    WIN_ttlb(no)
int     no;
{
    int     i;
    register WIN_PTR *cp;

    cp = &(wind[no]);
    dsp_lin[cp->wind_y-1] = (-2);

    color(7-(no&3),no == act_wind ? TRUE:FALSE);
    locate(0,cp->wind_y-1);
    for ( i = 80 ; i > 0 ; i-- )
	cputs("\033\x95");
    if ( cp->file != NULL ) {
        locate(39 - strlen(cp->file) / 2,cp->wind_y-1);
        cprintf("[%s]",cp->file);
	color(7,FALSE);
    }
    cp->dsp_pos = cp->dsp_wrt = ERR;
    WIN_stat(no);
}
void    WIN_disp(no)
int     no;
{
    int     i;
    register WIN_PTR *cp;

    WIN_ttlb(no);
    WIN_screen(no);
    cp = &(wind[no]);
    if ( (cp->wind_y + cp->max_y) < 23 ) {
	dsp_lin[cp->wind_y+cp->max_y] = (-2);
        locate(0,cp->wind_y+cp->max_y);
	for ( i = 80 ; i > 0 ; i-- )
	    cputs("\033\x95");
    }
    locate(cp->cur_x,cp->wind_y + cp->cur_y);
}
void    WIN_all()
{
    int     i;

    for ( i = 0 ; i < WIND_MAX ; i++ ) {
        if ( wind[i].file != NULL )
            WIN_disp(i);
    }
}
int     WIN_free(no)
int     no;
{
    int     i,n;
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p;

    cp = &(wind[no]);

    if ( cp->file == NULL )
        return FALSE;

    if ( cp->wrt_flg != FALSE ) {
        p = input("Not Save ? ","");
        if ( p == NULL || toupper(*p) != 'Y' )
            return ERR;
    }

    if ( (n = cp->now_ptr) != ERR ) {
        lp = get_lin(n);
        n = lp->right;
        while ( n != ERR ) {
            lp = get_lin(n);
            i = lp->right;
            xfree(n);
            n = i;
        }
        n = cp->now_ptr;
        while ( n != ERR ) {
            lp = get_lin(n);
            i = lp->left;
            xfree(n);
            n = i;
        }
    }

    if ( cp->fp != NULL ) {
        fclose(cp->fp);
        cp->fp = NULL;
    }

    free(cp->file);
    cp->file = NULL;

    cp->now_ptr = ERR;
    cp->cur_x = cp->cur_y = 0;
    cp->wrt_flg = cp->wrt_mode = 0;
    cp->dsp_pos = cp->dsp_wrt = ERR;
    cp->lin_pos = cp->lin_max = 0;

    return FALSE;
}
int     WIN_cheng()
{
    int     n,i;

    if ( (i = act_wind + 1) >= WIND_MAX )
        i = 0;

    while ( i != act_wind ) {
        if ( wind[i].file != NULL ) {
            n = act_wind;
            act_wind = i;
            cursol(0);
            WIN_ttlb(n);
            WIN_disp(act_wind);
            return FALSE;
        }
        if ( ++i >= WIND_MAX )
            i = 0;
    }
    return ERR;
}
int     main_func(rc)
int     rc;
{
    int     i,n;
    char    *p;
    static char tmp[128];

    switch(rc) {
    case 0:                     /* 1 Save & End           */
        if ( put_file(act_wind) )
            return FALSE;
        WIN_free(act_wind);
        if ( WIN_cheng() )
            return ERR;
        break;

    case 1:                     /* 2 All Save (ύX ̧) */
        do {
            if ( put_file(act_wind) )
                return FALSE;
            WIN_free(act_wind);
        } while ( !WIN_cheng() );
        return ERR;

    case 2:                     /* 3 Update File          */
        if ( put_file(act_wind) )
            return FALSE;
        break;

    case 3:                     /* 4 Change File Name     */
        if ( (p = input("Change File Name ? ",
                wind[act_wind].file)) == NULL )
            break;
        free(wind[act_wind].file);
        wind[act_wind].file = strdup(p);
        WIN_disp(act_wind);
        break;

    case 4:                     /* 5 Read File            */
        if ( (p = input("Read File ? ","")) == NULL )
            break;
        read_file(act_wind,p);
        break;

    case 5:                     /* 6 Quit                 */
        if ( WIN_free(act_wind) )
            return FALSE;
        if ( WIN_cheng() )
            return ERR;
        break;

    case 6:                     /* 7 All Quit             */
        do {
            if ( WIN_free(act_wind) )
                return FALSE;
        } while ( !WIN_cheng() );
        return ERR;

    case 7:                     /* 8 Original File(ĕҏW)*/
        strcpy(tmp,wind[act_wind].file);
        if ( !WIN_free(act_wind) )
            WIN_open(act_wind,tmp);
        break;

    case 8:                     /* 9 New File Edit        */
        if ( (p = input("New File Edit ? ","")) == NULL )
            break;
        for ( i = 0 ; i < WIND_MAX ; i++ ) {
            if ( wind[i].file == NULL ) {
                WIN_open(i,p);
                n = act_wind;
                act_wind = i;
                WIN_ttlb(n);
                WIN_disp(act_wind);
                break;
            }
        }
        break;
    }
    return FALSE;
}
int     Edt_loop()
{
    int     i,ch,n,fg;
    register WIN_PTR *cp;
    static char tmp[80];
    static struct {
        int     key;
        int     (*proc)();
    } key_tbl[]={
        { 0x000D,   KEY_cr },
        { 0x0009,   KEY_tab },
        { 0x0008,   KEY_bs },
        { 'N'-'@',  INS_line },
        { 0x001E,   KEY_up },
        { 0x001F,   KEY_down },
        { 'E'-'@',  KEY_up },
        { 'X'-'@',  KEY_down },
        { 'Z'-'@',  KEY_uscr },
        { 'W'-'@',  KEY_dscr },
        { 'R'-'@',  KEY_upage },
        { 'C'-'@',  KEY_dpage },
        { 'S'-'@',  KEY_left },
        { 'D'-'@',  KEY_right },
        { 0x001D,   KEY_left },
        { 0x001C,   KEY_right },
        { 'F'-'@',  KEY_wright },
        { 'A'-'@',  KEY_wleft },
        { 'Y'-'@',  DEL_line },
        { 0x007F,   KEY_del },
        { 'G'-'@',  KEY_ldel },
        { 'T'-'@',  KEY_rdel },
        { 'U'-'@',  KEY_undo },
        { 'P'-'@',  KEY_ins_sw },
        { 'B'-'@',  KEY_serch },
        { '@'-'@',  KEY_cut },
        { 'L'-'@',  KEY_paste },
        { 'V'-'@',  WIN_cheng },
        { 0x1100+'A'-'@',   KEY_tline },
        { 0x1100+'F'-'@',   KEY_bline },
        { 0x1100+'R'-'@',   KEY_tfile },
        { 0x1100+'C'-'@',   KEY_bfile },
        { 0x1100+'Q'-'@',   CMD_sub1 },
        { 0x1100+'S'-'@',   MAC_save },
        { 0x1100+'A'-'@',   MAC_go },
        { 0xFFFF,   KEY_cr }
    };
    static int  main_cmd=(-1);
    static char *main_menu[]={
        "1 Save & End           ",
        "2 All Save (ύX ̧) ",
        "3 Update File          ",
        "4 Change File Name     ",
        "5 Read File            ",
        "6 Quit                 ",
        "7 All Quit             ",
        "8 Original File(ĕҏW)",
        "9 New File Edit        ",
        NULL
    };

    fg = FALSE;
    n = 0;
    while ( kbhit() ) {
        fg = TRUE;
        ch = getch();
        if ( ch == '\x1B' && menu(&main_cmd,3,main_menu) &&
                             main_cmd >= 0 ) {
            if ( n > 0 ) {
                tmp[n] = '\0';
                WIN_puts(act_wind,tmp);
                n = 0;
            }
            WIN_flush(act_wind);
            if ( main_func(main_cmd) )
                return ERR;
 
        } else if ( ch < ' ' || ch == '\x7F' || (ch & 0xFF00) != 0 ) {
            for ( i = 0 ; key_tbl[i].key != 0xFFFF ; i++ ) {
                if ( key_tbl[i].key == ch ) {
                    if ( n > 0 ) {
                        tmp[n] = '\0';
                        WIN_puts(act_wind,tmp);
                        n = 0;
                    }
                    (*key_tbl[i].proc)();
                    break;
                }
            }

        } else {
            if ( n >= 80 ) {
                tmp[n] = '\0';
                WIN_puts(act_wind,tmp);
                n = 0;
            }
            tmp[n++] = ch;
        }
    }
    if ( n > 0 ) {
        tmp[n] = '\0';
        WIN_puts(act_wind,tmp);
    }

    if ( fg != FALSE ) {
        cursol(0);
        WIN_flush(act_wind);
        cp = &(wind[act_wind]);
        locate(cp->cur_x,cp->wind_y + cp->cur_y);
        cursol(1);
    }
    return FALSE;
}
int     main(argc,argv)
int     argc;
char    *argv[];
{
    int     i;
    char    *p;
    char    *tmp=NULL;
    char    *filev[WIND_MAX];

    tmp = getenv("TMP");
    while ( --argc > 0 ) {
        p = *(++argv);
        if ( *p == '-' ) {
            p++;
            switch(toupper(*p)) {
            case 'W':
                if ( *(++p) == '=' ) p++;
                tmp = p;
                break;
            case 'T':
                if ( *(++p) == '=' ) p++;
                TAB = atoi(p);
                break;
            default:
                printf("use: whis <file..> [-w=<tmp>] [-t=nn]\n");
                exit(0);
            }
        } else if ( max_wind < WIND_MAX )
            filev[max_wind++] = p;
    }

    if ( max_wind == 0 ) {
        printf("use: whis <file..> [-w=<tmp>] [-t=nn]\n");
        exit(216);
    }

    CON_init();
    BUF_init(tmp);
    WIN_init();

    for ( i = 0 ; i < max_wind ; i++ ) {
        WIN_open(i,filev[i]);
        WIN_disp(i);
    }

    if ( max_wind > 1  )
        WIN_disp(act_wind);

    while ( !Edt_loop() );

    BUF_end();
    CON_end();
    cursol(1);
}
