;	'CLOCK WAIT' COMMAND FOR REAL-MODE
;	cw n(0-3,4-7)

	.8086

CODE	segment
	assume	cs:CODE,ds:CODE,es:CODE,ss:CODE

	org	100h	; .COM model
cmdln	equ	80h
cmdprm	equ	81h

CW	proc
	mov	si,cmdprm		; 󔒃XLbv
skipf:	cmp	byte ptr [si],0Dh	; p[^IH
	je	check
	cmp	byte ptr [si],' '	; Xy[XH
	je	next
	cmp	byte ptr [si],09h	; ^uH
	jne	check
next:	inc	si
	jmp	skipf
check:	mov	dx,0030h	; @픻
	in	al,dx
	cmp	al,1
	jne	not_towns
	inc	dx
	in	al,dx
	cmp	al,1
	je	old_towns
	cmp	al,2
	je	new_towns
	cmp	al,4
	jne	not_towns
	jmp	new2_towns      
not_towns:			; TOWNSł͂Ȃ
	mov	dx,offset msg4
exit2:	mov	ah,09h
	int	21h
exit:	mov	ax,4C00h
	int	21h

old_towns:			; TOWNS̏ꍇ
	mov	dx,05E0h
	mov	al,[si]
	cmp	al,'N'
	jne	lp1
	mov	al,1
	out	dx,al
	jmp	exit
lp1:	cmp	al,'B'
	jb	status_old
	cmp	al,'E'
	ja	status_old
	sub	al,'B'-4
	out	dx,al
	jmp	exit
status_old:
	mov	dx,offset msg5
	mov	ah,09h
	int	21h
	mov	dx,offset msg2
	mov	ah,09h
	int	21h
	mov	dx,05E0h
	in	al,dx
	mov	dx,offset msg
	cmp	al,1
	jne	lp2
	mov	byte ptr cs:msg[21],'N'
	jmp	exit2
lp2:	add	al,'B'-4
	mov	msg[21],al
	jmp	exit2

new_towns:			; VTOWNS̏ꍇ
        mov     dx,05E2h
        mov     al,[si]
        cmp     al,'N'
        jne     lp3
        mov     al,83h
        out     dx,al
        jmp     exit
lp3:    cmp     al,'A'
        jb      status_new
        cmp     al,'E'
        ja      status_new
        sub     al,'A'-1
        out     dx,al
        jmp     exit
status_new:
	mov	dx,offset msg5
	mov	ah,09h
	int	21h
        mov     dx,offset msg3
        mov     ah,09h
        int     21h
        mov     dx,05E2h
        in      al,dx
        mov     dx,offset msg
        cmp     al,83h
        jne     lp4
        mov     byte ptr cs:msg[21],'N'
        jmp     exit2
lp4:    add     al,'A'-1
        mov     msg[21],al
        jmp     exit2




new2_towns:			; VVTOWNS̏ꍇ
        mov     dx,05E2h
        mov     al,[si]
        cmp     al,'N'
        jne     lp5
        mov     al,83h
        out     dx,al
        jmp     exit
lp5:    cmp     al,'0'
        je      lp5_2
        cmp     al,'A'
        jb      status_new2
        cmp     al,'E'
        ja      status_new2
        sub     al,'A'-1
lp5_:   out     dx,al
        jmp     exit
lp5_2:  mov     al,0
        jmp     lp5_
status_new2:
	mov	dx,offset msg5
	mov	ah,09h
	int	21h
        mov     dx,offset msg3_
        mov     ah,09h
        int     21h
        mov     dx,05E2h
        in      al,dx
        mov     dx,offset msg
        cmp     al,83h
        jne     lp6
        mov     byte ptr cs:msg[21],'N'
        jmp     exit2
lp6:    add     al,'A'-1
        cmp     al,'A'-1
        je      lp8
lp7:    mov     msg[21],al
        jmp     exit2
lp8:    mov     al,'0'
        jmp     lp7







CW	endp

cr	equ	0Dh
lf	equ	0Ah
msg	db      "݂̃EFCg|h=  ",cr,lf,cr,lf 
        db      "HELP: AB <mode(A-E & N)>",cr,lf
	db	"mode: 0 <- A <- B <- C <- D <- E ᑬ",cr,lf
	db	" m[} NixCƓj",cr,lf
	db	"FFM TOWNS f1/2ł́uB modev܂ŁAf1F/2F/1H/2Hł́uA modev܂łwł܂B",cr,lf,"$"
msg2	db	"< FM TOWNS f1/2 >",cr,lf,"$"
msg3	db	"< FM TOWNS f1F/2F/1H/2H >",cr,lf,"$"
msg3_	db	"< FM TOWNS f10F/20F/40H/80H >",cr,lf,"$"
msg4	db	"< FM TOWNSł͂܂ >",cr,lf,"$"
msg5    db      "<<< `fteraurner.bnl Version 2.0 >>>",cr,lf,"$"

CODE	ends
	end	cw
