/** << MSC V5.1 >> ************************************************************
**
**	-----  bctvO -----------------------------------------------
**	int CDplay( int tocread, int startno, int endno, unsigned char repeat ) ;
**
**	<input>		: tocread - =1(!=0) TOC ̎擾B
**                          =0      TOC ̎擾͂ȂB
**              : startno - tJnȔԍ
**              : endno   - tIȔԍ
**              : repeat  - s[g
**
**	<return>	: = 0 - I
**				: = 1 - G[
**
**	----- HISTORY -----
**	1990.02.21 : CREATE
**	1990.07.03 : CDײނ޲o^ĂȂүޒǉ
**
**	Programed by Y.Hirata ( Nifty ID : NAB03321 )
**
******************************************************************************/
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	"cdr.h"
#include	<dos.h>

#define		DEBUG		0

#define		TRUE		1
#define		FALSE		0

#define		RETRY		10		/*  G[̃gC		*/

static char TOCON = FALSE ;		/*  snb̎擾ςH			*/

#define		Cddrv		0			/*  bchCuԍ ( 0 - 6 )	*/
									/*  TOWNSł Cddrv=0 ̂		*/
int	Cdtype ;						/*	bc^Cv					*/
int	Sttrack ;						/*	擪gbN()ԍ		*/
int	Endtrack ;						/*	ŏIgbN()ԍ		*/
int	Status ;						/*	ỷt				*/
int	Nowmusicno ;					/*	݉t̋Ȕԍ			*/

typedef struct _TOC {
		char	min ;
		char	sec ;
		char	frame ;
} TOC ;

static TOC Trtime[99],Endtime,Disctime,Nowtime,Usest,Useet ;
/*
**	Trtime[99] : egbN̉tJn
**	Endtime    : fBXNtI
**	Disctime   : fBXNt
**	Nowtime    : t̃gbNt
**	Usest      : tJnw莞
**	Useet      : tIw莞
*/

/***************************  bc̎擾  ********************************/
/*
**	܂́Ã[`ŃRpNgfBXN( CD )̏擾܂B
*/
int cdinfo()
{
	return(
		CDR_cdinfo
		( Cddrv,&Cdtype,&Sttrack,&Endtrack,(char *)Trtime,(char *)&Endtime )
	) ;
}

/*******************************  bct  **********************************/
/*				
**		A~`WbNEX^[gI
**		Ԏwɂ鉹yt܁`I
**
**	<input>		: count - t(s[g)
*/
int mtrplay( unsigned char count )
{
	return(
		CDR_mtrplay( Cddrv,(char *)&Usest,(char *)&Useet,count )
	) ;
}

/***************************  bctԂ̎擾  ****************************/
/*				
**		AỷtԂ͂ǁ`ȂĂ邩ȂHI
*/
int mphase()
{
	return(
		CDR_mphase
		( Cddrv,&Status,&Nowmusicno,(char *)&Nowtime,(char *)&Disctime )
	) ;
}

/***************************  tJnԂ̐ݒ  ****************************/
/*
**	<input>		: trackno - tJngbN(Ȕԍ)
*/
void usestset( int trackno )
{
	if ( trackno<Sttrack )	trackno = Sttrack ;
	if ( trackno>Endtrack )	trackno = Endtrack ;

	if ( Cdtype==3 && trackno==Sttrack ) trackno++ ;

	Usest.sec   = Trtime[trackno-1].sec ;
	Usest.min   = Trtime[trackno-1].min ;
	Usest.frame = Trtime[trackno-1].frame ;

	printf("START (%02d) - ",trackno) ;
}

/*************************  tIԂ̐ݒ  ******************************/
/*
**	<input>		: trackno - tIgbN(Ȕԍ)
*/
void useetset( int trackno )
{
/*	frame : 0 - 74 : 75frame=1sec	*/

	if ( trackno<Sttrack ) trackno = Sttrack ;
	if ( Cdtype==3 && trackno==Sttrack ) trackno++ ;
/*
**	Ō̋Ȃ܂(܂͍Ō̋Ȃ)t`ɂ́A
**	tIԂ̎wɒӂ܂傤I
**
**	 tIԂ́AfBXNtIԂ 1 t[lw
**	   ȂƂ߂I
*/
	if ( trackno>=Endtrack ) {			/*  ŏIȂw肳ꂽ	*/
		trackno = Endtrack ;
		Useet.sec = Endtime.sec ;
		Useet.min = Endtime.min ;
		if ( !Endtime.frame ) {
			Useet.frame = 74 ;
			if ( !Endtime.sec ) {
				Useet.sec  = 59 ;
				Useet.min -= 1 ;
			} else
				Useet.sec = Endtime.sec-1 ;
		} else
			Useet.frame = Endtime.frame-1 ;
	} else {							/*  ŏIȂȂ		*/
		Useet.sec   = Trtime[trackno].sec ;
		Useet.min   = Trtime[trackno].min ;
		Useet.frame = Trtime[trackno].frame ;
	}

	printf("END (%02d) : ",trackno) ;
}

/*******************************  ޲װ  *********************************/
char	*msg[] = {
	"G[ : ݒA{vO̎gp߂ĉ",
	"lr|cnrŎgpꍇɂ́A'CDDRV.SYS'  'CDISC.SYS' ̃foCX",
	"hCoKvłB"
				} ;
void deverr()
{
	printf("\x1b[31m") ;
	printf("%s\n",msg[0]) ;
	printf("\x1b[33m") ;
	printf("") ;
	printf("%s\n",msg[1]) ;
	printf("%s\n",msg[2]) ;
	printf("\x1b[m") ;
}

/**************************  bc̉t܂B ****************************/
/*
**	<input>		: tocon   - =1(!=0) TOC ̎擾B
**                          =0      TOC ̎擾͂ȂB
**              : startno - tJnȔԍ
**              : endno   - tIȔԍ
**              : repeat  - s[g
**
**	<return>	: = 0 - I
**				: = 1 - G[
*/
int CDplay( int tocread, int startno, int endno, unsigned char repeat )
{
	int	errcnt ;
	int	err=FALSE ;

	if ( !repeat ) repeat = 1 ;

	if ( !TOCON || tocread ) {
		errcnt = 0 ;
		do {
			err = cdinfo() ;
			if ( err == DEVERR ) {
				deverr() ;
				exit( 1 ) ;
			}
			CDR_pause( Cddrv ) ;
#if DEBUG
			printf("error(%02d) : -cdinfo- %xH\n",errcnt,err) ;
#endif
			errcnt++ ;
		} while ( err && errcnt<=RETRY ) ;
		if ( errcnt<=RETRY ) {
			TOCON = TRUE ;
		} else {
#if DEBUG
			printf("-cdinfo- error : %xH\n",err) ;
#endif
			printf("\nbcZbgĂ܂I\n") ;
			err = TRUE ;
			goto close ;
		}
	}
	err = 0 ;
#if	DEBUG
	printf("cdtype     : %d\n",Cdtype) ;
	printf("starttrack : %d\n",Sttrack) ;
	printf("endtrack   : %d\n",Endtrack) ;
	for ( err=0; err<Endtrack; err++ ) {
		printf("min-sec-frame(%02d) : %02d-%02d-%02d\n",
				err,Trtime[err].min,Trtime[err].sec,Trtime[err].frame) ;
	} ;
	err = 0 ;
#endif
/*
**	CDDA ̂ȂRpNgfBXNɂ͗pȂ̂ŁAvOII
*/
	if ( Cdtype!=1 && Cdtype!=3 ) {
		printf("\ny̓ĂȂbĉ߁Atł܂I\n") ;
		err = TRUE ;
		goto close ;
	}

	if ( Endtrack<=0 || Endtrack>99 ) goto close ;
	if ( Endtime.frame<=0 && Endtime.sec<=0 && Endtime.min<=0 ) goto close ;

	errcnt = 0 ;
	usestset( startno ) ;
	useetset( endno ) ;
	printf("REPEAT (%02d)\n",repeat) ;
	do	{										/*  tJn			*/
		if ( mtrplay( repeat ) == 0x102 ) CDR_pause( Cddrv ) ;
		mtrplay( repeat ) ;		mphase() ;
		if ( ++errcnt >= RETRY ) {
			printf("\n<cdplay> CD READ ERROR (mtrplay)") ;
			err = TRUE ;
			goto close ;
		}
	} while ( !Status );

close:
	return( err ) ;
}

