/******************************************************************************
**
**		KEY.LIB << MSC V5.1 >>
**
**		<HISTORY>
**		1990.07.03 : CREATE
**
**		Programed by Y.HIRATA Nifty-ID (NAB03321)
**
******************************************************************************/

#define	TRUE	1
#define	FALSE	0

#define	KEY_INT	0x90

/****************************  10us PʂłWAIT  ****************************/
void soft_time( unsigned short waitcount ) ;

/******************************************************************************
	KEY_read : ꕶ(L[{[h)
	< RETURN >
	R[h, ͂Ȃ̏ꍇɂ 0 Ԃ
******************************************************************************/
unsigned	KEY_read( unsigned waitsw, unsigned *encode ) ;

/******************************************************************************
	KEY_matrix : }gNX
******************************************************************************/
int		KEY_matrix( char *matrix ) ;

/******************************************************************************
	KEY_test : }gNXL[Ă邩ǂ`FbNB
******************************************************************************/
int		KEY_test( char *matrix, char keyadrs ) ;

/******************************************************************************
	KEY_bufcls : obt@NA
******************************************************************************/
int		KEY_bufcls( void ) ;

/***************************  ^C 󂯕tȂ  *************************/
int inkey( void ) ;


/*
**	KEY ڽ
*/

#define		KEY_A			0x1E
#define		KEY_B			0x2E
#define		KEY_C			0x2C
#define		KEY_D			0x20
#define		KEY_E			0x13
#define		KEY_F			0x21
#define		KEY_G			0x22
#define		KEY_H			0x23
#define		KEY_I			0x18
#define		KEY_J			0x24
#define		KEY_K			0x25
#define		KEY_L			0x26
#define		KEY_M			0x30
#define		KEY_N			0x2F
#define		KEY_O			0x19
#define		KEY_P			0x1A
#define		KEY_Q			0x11
#define		KEY_R			0x14
#define		KEY_S			0x1F
#define		KEY_T			0x15
#define		KEY_U			0x17
#define		KEY_V			0x2D
#define		KEY_W			0x12
#define		KEY_X			0x2B
#define		KEY_Y			0x16
#define		KEY_Z			0x2A

#define		KEY_0			0x0B
#define		KEY_1			0x02
#define		KEY_2			0x03
#define		KEY_3			0x04
#define		KEY_4			0x05
#define		KEY_5			0x06
#define		KEY_6			0x07
#define		KEY_7			0x08
#define		KEY_8			0x09
#define		KEY_9			0x0A

#define		KEY_ESC			0x01
#define		KEY_ALP			0x6A
#define		KEY_alp			0x6F
#define		KEY_SHIFT		0x53
#define		KEY_CTRL		0x52

#define		KEY_TAB			0x10
#define		KEY_SPACE		0x35
#define		KEY_BACK		0x0F
#define		KEY_UNDO		0x72
#define		KEY_DIC			0x59
#define		KEY_CR			0x1D

#define		KEY_EXEC		0x73

#define		KEY_UP			0x4D
#define		KEY_DOWN		0x50
#define		KEY_RIGHT		0x51
#define		KEY_LEFT		0x4F

#define		KEY_DIC_SER		0x6B
#define		KEY_DIC_DEL		0x6C
#define		KEY_DIC_ADD		0x6D
#define		KEY_BEFORE		0x6E
#define		KEY_HOME		0x4E
#define		KEY_NEXT		0x70
#define		KEY_HALF		0x71
#define		KEY_DEL			0x4B
#define		KEY_INS			0x48

#define		KEY_PF1			0x5D
#define		KEY_PF2			0x5E
#define		KEY_PF3			0x5F
#define		KEY_PF4			0x60
#define		KEY_PF5			0x61
#define		KEY_PF6			0x62
#define		KEY_PF7			0x63
#define		KEY_PF8			0x64
#define		KEY_PF9			0x65
#define		KEY_PF10		0x66
#define		KEY_PF11		0x69
#define		KEY_PF12		0x5B
#define		KEY_PF13		0x74
#define		KEY_PF14		0x75
#define		KEY_PF15		0x76
#define		KEY_PF16		0x77
#define		KEY_PF17		0x78
#define		KEY_PF18		0x79
#define		KEY_PF19		0x7A
#define		KEY_PF20		0x7B

#define		KEY_BREAK		0x7C
#define		KEY_COPY		0x7D

#define		KEY_SUB			0x0C
#define		KEY_TOPBER		0x0D
#define		KEY_OR			0x0E
#define		KEY_RKAKKO		0x29
#define		KEY_COLON		0x28
#define		KEY_LKAKKO		0x1C
#define		KEY_SEMICOLON	0x27
#define		KEY_LT			0x31
#define		KEY_GT			0x32
#define		KEY_QUEST		0x33
#define		KEY_UNDERBER	0x34

#define		TKEY_ASTER		0x36
#define		TKEY_SLASH		0x37
#define		TKEY_ADD		0x38
#define		TKEY_SUB		0x39
#define		TKEY_EQU		0x3D
#define		TKEY_PIRIOD		0x47
#define		TKEY_CR			0x45
#define		TKEY_0			0x46
#define		TKEY_1			0x42
#define		TKEY_2			0x43
#define		TKEY_3			0x44
#define		TKEY_4			0x3E
#define		TKEY_5			0x3F
#define		TKEY_6			0x40
#define		TKEY_7			0x3A
#define		TKEY_8			0x3B
#define		TKEY_9			0x3C
#define		TKEY_000		0x4A

