#define LoWORD(l)       ((unsigned short)(l))
#define HiWORD(l)       ((unsigned short)(((unsigned long)(l) >> 16) & 0xffff))
#define LiBYTE(w)       ((unsigned char)(w))
#define HiBYTE(w)       (((unsigned short)(w) >> 8) & 0xff)

#define DWORD(x)        *((unsigned long int *)(x))
#define WORD(x)         *((unsigned short int *)(x))
#define BYTE(x)         *((unsigned char *)(x))
#define PAI             3.141593

#define _IGRB(i, g, r, b) (((i) << 24) + ((r) << 16) + ((b) << 8) + (g))
#define _RGB(r, g, b)    (((unsigned long) ((b) << 8 | (g)) << 8) | (r))
#define GetRVal(rgb)  ((unsigned char)(rgb))
#define GetGVal(rgb)  ((unsigned char)(((unsigned short)(rgb)) >> 8))
#define GetBVal(rgb)  ((unsigned char)((rgb) >> 16))

typedef struct {
    int     x;
    int     y;
} POS;

typedef struct {
    int     left;
    int     top;
    int     right;
    int     bottom;
} RECT;

#define FONT_NORM       0x0000
#define FONT_THICK      0x0001
#define FONT_SLIDE      0x0002
#define FONT_SHADOW     0x0004
#define FONT_FRAME      0x0008
#define FONT_UNDER      0x0010
#define FONT_OVER       0x0020
#define FONT_CENTER     0x0040

#define BLACK           0x0000
#define DARKBLUE        0x0001
#define DARKRED         0x0002
#define DARKCYAN        0x0003
#define DARKGREEN       0x0004
#define DARKMAGENTA     0x0005
#define BROWN           0x0006
#define LIGHTGRAY       0x0007
#define DARKGRAY        0x0008
#define BLUE            0x0009
#define GREEN           0x000c
#define CYAN            0x000b
#define RED             0x000a
#define MAGENTA         0x000d
#define YELLOW          0x000e
#define WHITE           0x000f

