/*
 *	button.h
 */
#ifndef	_BUTTON_H
#define	_BUTTON_H


typedef	struct	button	{
	struct button	*next;
	char		*string;	/* {^ɕ\镶 */
	int		btnId;
	int		enable;		/* 0:͊DF\, !0:\ */
	int		on;
	int		repeat;		/* repeat */
	int		luX;		/* {^̍wW */
	int		luY;		/* {^̍xW */
}	button_t;
/*
	--------------------------+	: luX, luY
	|		     8	    |
	|   +-------------------+   |
	|   |		     |	|   |
	| 8 |		    16	| 8 |	2hbg̓IIt]̈
	|   |		     |	|   |
	|   +-------------------+   |
	|		     8	    |
	+---------------------------+
*/


extern	int
BTN_create(
	button_t	*btn);
/*
 *	PURPOSE
 *		w肳ꂽp^Ń{^쐬C\C{^IDԂD
 *		w肷ׂp^(button_t̃o)͈ȉ̒ʂD
 *			string, enable, repeat, luX, luY
 *	RETURNS
 *		>= 0	: {^ID
 *		-1	: {^̐s
 *	NOTICE
 *		{֐̓p^œnꂽ{^\̂
 *		ostrinĝ܂ܕێ邽߁C
 *		ďostringw̕j󂵂Ă͂ȂȂD
 *	IMPLEMENT
 *		{͓IɃmۂׂC
 *		ł͂Ƃ肠Œ̈gpD
 */
extern	void
BTN_allDestroy(void);
/*
 *	PURPOSE
 *		S{^폜D
 *	IMPLEMENT
 *		{͌ʂ̃{^ЂƂĂׂC
 *		ł_BT_NextButton邾ƂD
 */
extern	int
BTN_setName(
	int	btnId,
	char	*string);	/* ύX̃{^ */
/*
 *	PURPOSE
 *		w肳ꂽ{^̃{^C
 *		w肳ꂽ{^Ƃĕ\D
 *		{^ƐV{^͓̒ƁD
 *	RETURNS
 *		0	: I
 *		-1	: {^IDȂ
 *	NOTICE
 *		{֐̓p^strinĝ܂ܕێ邽߁C
 *		ďostringw̕j󂵂Ă͂ȂȂD
 */
extern	int
BTN_enable(
	int	btnId,
	int	enable);
/*
 *	PURPOSE
 *		w肳ꂽ{^̗LԂύXC\D
 *	RETURNS
 *		0	: I
 *		-1	: {^IDȂ
 */
extern	int
BTN_reverse(
	int	btnId);
/*
 *	PURPOSE
 *		w肵{^̃IIt𔽓]C\D
 *	RETURNS
 *		0	: I
 *		-1	: {^IDȂ
 */
extern	int
BTN_posCheck(
	int	btnId,
	int	x,
	int	y);
/*
 *	PURPOSE
 *		w肵W{^ۂ𔻒肵ČʂʒmD
 *		w肵{^enablełȂ΁C̎|ʒmD
 *	RETURNS
 *		1	: wW̓{^
 *		0	: {^O
 *		-1	: {^IDȂ
 *		-2	: {^enablełȂ
 */
extern	int
BTN_isRepeat(
	int	btnId);
/*
 *	PURPOSE
 *		w肵{^RepeatۂʒmD
 *	RETURNS
 *		1	: Repeat
 *		0	: RepeatȂ
 *		-1	: {^IDȂ
 */
extern	int
BTN_isEnable(
	int	btnId);
/*
 *	PURPOSE
 *		w肵{^enableԂۂʒmD
 *	RETURNS
 *		1	: enableԂł
 *		0	: enableԂłȂ
 *		-1	: {^IDȂ
 */
extern	int
BTN_getButtonEvent(
	int	buttonIds[]);
/*
 *	PURPOSE
 *		}EXŃNbNꂽ_CAO{^
 *		zCfbNXiCxgIDjʒmD
 *		`FbN_CAO{^ID́C
 *		buttonIds[]Ŏw肷D
 *		ŏIID̗̎vfɂ-1i[ĂƁD
 *	RETURNS
 *		zCfbNXiCxgIDj
 */


#endif
/*****	button.h  *****/
