/*
 *	msdos.c
 *		MS-DOSC^tF[X֐Q
 */

#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>
#include	"msdos.h"


/****************************************/
/*		萔`		*/
/****************************************/

#define		GLOBAL

/*	intdos() G[`FbNp	*/
#define		CarryBit	0x0001


/********************************************************/
/*	Microsoft C 5.1 ^CECu݊֐	*/
/********************************************************/

GLOBAL	void
_dos_getdrive(
	unsigned	*drive)
/*
 *	PURPOSE
 *		JghCuʒmD
 *	RETURNS
 *		drive֕ԂĺChCuA=1ChCuB=2...
 *	REMARKS
 *		MSCƓdl
 */
{
	union	REGS	inregs, outregs;
	
	inregs.h.ah = 0x19;		/* Get Current Disk Drive */
	intdos(&inregs, &outregs);
	*drive = outregs.h.al + 1;
}
/* ---	_dos_getdrive()  --- */


GLOBAL	void
_dos_setdrive(
	unsigned	drive,
	unsigned	*maxDrive)	/* ő_hCu̒ʒm̈ */
/*
 *	PURPOSE
 *		JghCuύXCő_hCuʒmD
 *	RETURNS
 *		drive֐ݒ肷ĺChCuA=1ChCuB=2...
 *	REMARKS
 *		MSCƓdl
 */
{
	union	REGS	inregs, outregs;
	
	inregs.h.ah = 0x0e;		/* Select Disk */
	inregs.h.dl = drive - 1;
	intdos(&inregs, &outregs);
	*maxDrive = outregs.h.al;
}
/* ---	_dos_setdrive()  --- */


GLOBAL	int
_getDriveStatus(
	int	drive)
/*
 *	PURPOSE
 *		w肳ꂽhCȕԂʒmD
 *	RETURNS
 *		0 : \}(FPD)
 *		2 : s\}(HD)
 *		-1: gps
 */
{
	union REGS	inregs, outregs;
	
	inregs.h.ah = 0x44;			/* foCXo͐ */
	inregs.h.al = 0x08;			/* foCX\ */
	inregs.h.bl = drive;
	intdos(&inregs, &outregs);
	if (outregs.x.cflag & CarryBit)		/* G[`FbN */
		return(-1);
	return(outregs.x.ax == 0 ? 0 : 2);
}
/* ---	_getDriveStatus()  --- */


GLOBAL	char	*
getcwd(
	char	*path,		/* tpXʒm̈ */
	int	n)		/* pathp^̗̈撷 */
/*
 *	PURPOSE
 *		JgfBNg̃tpXԂD
 *		[gfBNg '\' ͊܂܂ȂD
 *		pathNULL̏ꍇC{֐mallocĕKvȗ̈mۂD
 *	RETURNS
 *		pXւ̃|C^
 *		G[ NULL
 *	REMARKS
 *		MSCƓdl
 */
{
	union REGS	inregs, outregs;
	char		buf[128];
	int		pathLen;
	
	inregs.h.ah = 0x47;	/* JgfBNg̎擾 */
	inregs.h.dl = 0;	/* JghCuw */
	inregs.e.esi = (unsigned int)&buf;
	intdos(&inregs, &outregs);
	if (outregs.x.cflag & CarryBit)		/* G[`FbN */
		return(NULL);
	pathLen = strlen(buf);
	if (path == NULL) {
		path = (char *)malloc(pathLen);
		if (path == NULL)
			return(NULL);
		n = pathLen;
	}
	else if (pathLen >= n)
		return(NULL);
	return(strncpy(path, buf, n));
}
/* ---	getcwd()  --- */


GLOBAL	int
chdir(
	char	*path)
/*
 *	PURPOSE
 *		JghCũJgfBNgύX
 *	RETURNS
 *		0	: I
 *		-1	: G[
 *	REMARKS
 *		MSCƓdl
 */
{
	union REGS	inregs, outregs;
	
	inregs.h.ah = 0x3b;		/* JgfBNg̕ύX */
	inregs.e.edx = (unsigned int)path;
	intdos(&inregs, &outregs);
	if (outregs.x.cflag & CarryBit)		/* G[`FbN */
		return(-1);
	return(0);
}
/* ---	chdir()  --- */


GLOBAL	unsigned
_dos_findfirst(
	char		*path,		/* Ώۃt@C */
	unsigned	attr,		/* Ώۑ */
	struct find_t	*buf)
/*
 *	PURPOSE
 *		w肵t@C̃t@CbufŒʒmD
 *	RETURNS
 *		0			: 
 *		MS-DOSG[R[h	: s
 *	REMARKS
 *		MSCƓdl
 */
{
	union REGS	inregs, outregs;
	
	inregs.h.ah = 0x1a;			/* DTAAhX̐ݒ */
	inregs.e.edx = (unsigned int)buf;
	intdos(&inregs, &outregs);
	
	inregs.h.ah = 0x4e;			/* ŏ̃t@Č */
	inregs.x.cx = attr;
	inregs.e.edx = (unsigned int)path;
	intdos(&inregs, &outregs);
	if (outregs.x.cflag & CarryBit)		/* G[`FbN */
		return(outregs.x.ax);
	return(0);
}
/* ---	_dos_findfirst()  --- */


GLOBAL	unsigned
_dos_findnext(
	struct find_t	*buf)
/*
 *	PURPOSE
 *		_dos_findfirst()ŔȊÕt@C
 *		t@CbufŒʒmD
 *	RETURNS
 *		0			: 
 *		MS-DOSG[R[h	: s
 *	REMARKS
 *		MSCƓdl
 */
{
	union REGS	inregs, outregs;
	
	inregs.h.ah = 0x1a;			/* DTAAhX̐ݒ */
	inregs.e.edx = (unsigned int)buf;
	intdos(&inregs, &outregs);
	
	inregs.h.ah = 0x4f;			/* ̃t@Č */
	intdos(&inregs, &outregs);
	if (outregs.x.cflag & CarryBit)		/* G[`FbN */
		return(outregs.x.ax);
	return(0);
}
/* ---	_dos_findnext()  --- */


GLOBAL	unsigned char *
jstrrchr(
	unsigned char	*str,
	unsigned short	c)
/*
 *	PURPOSE
 *		str̒ōłŌɌꂽcւ̃|C^ԂD
 *	RETURNS
 *		not NULL	: cւ̃|C^
 *		NULL		: ł
 *	NOTICE
 *		c͂QoCgłĂ͂ȂȂD
 *		̓_MSC݊łD
 */
{
	unsigned short	ch;
	unsigned char	*pFound = NULL;
	
	if (str == NULL)
		return(NULL);
	
	while ((ch = *str++) != '\0') {
		if (iskanji(ch))
			str++;
		else if (ch == c)
			pFound = str - 1;
	}
	return(pFound);
}
/* ---	jstrrchr()  --- */


GLOBAL	int
iskanji(
	int	c)
/*
 *	PURPOSE
 *		cQoCg̑oCgł邩ۂ𒲂ׂD
 *	RETURNS
 *		1	: oCgł
 *		0	: oCgłȂ
 */
{
	if (c >= 0x81 && c <= 0x9f)
		return(1);
	if (c >= 0xe0 && c <= 0xfc)
		return(1);
	return(0);
}
/* ---	iskanji()  --- */


/****************************************/
/*		̑̊֐		*/
/****************************************/

/*	̂Ƃ͂Ȃ	*/

/*****	msdos.c  *****/
