/*
 *	txtentry.c
 */

#include	<stdlib.h>
#include	<string.h>
#include	<egb.h>
#include	<msdos.cf>
#include	"display.h"
#include	"mouse.h"
#include	"msdos.h"
#include	"txtentry.h"

#define		GLOBAL
#define		LOCAL		static

#define		TRUE		1
#define		FALSE		0


/*--------------------------------------*/
/*		萔`		*/
/*--------------------------------------*/

#define		CharWidth	8
#define		CharHeight	16

#define		TOP_X(p)	((p)->luX)
#define		TOP_Y(p)	((p)->luY)
#define		BTM_X(p)	((p)->rdX)
#define		BTM_Y(p)	((p)->rdY)
#define		FNT_X(p)	((p)->charWidth)
#define		FNT_Y(p)	((p)->charHeight)
#define		CUR_X(p)	((p)->cursorPos)
#define		CUR_Y(p)	(0)
#define		CUR_COL(p)	((p)->cursorColor)
#define		CHR_COL(p)	((p)->charColor)
#define		BAK_COL(p)	((p)->backColor)

#define		PIX_BYTE	2		/* 32KFʑΉ */


/*--------------------------------------*/
/*		}N`		*/
/*--------------------------------------*/

#define		min(x,y)	(((x)<(y)) ? (x) : (y))


/*--------------------------------------*/
/*		ϐ`		*/
/*--------------------------------------*/

LOCAL	textEntry_t	*TXT_activeField = NULL;
LOCAL	int		TXT_charColor[8];
LOCAL	int		TXT_attrColor[8];


/*--------------------------------------*/
/*	OAK2LIBpR[obN֐Q	*/
/*--------------------------------------*/

GLOBAL	void
OAK2_putstr(
	int	pos,
	int	len,
	char	*str,
	char	*attr)
/*
 *	PURPOSE
 *		KAN_read()Ăяo関m蕶\p
 *		R[obN֐
 *		Ȋϊ̓}EXJ[\̕\D
 *	IMPLEMENT
 *		(R)CMIYAZAKIɂ OAK2LIB ̃Tv𗬗pD
 */
{
	static	int	backLen = 0;
	static	char	*backBuf[128];
	textEntry_t	*tep = TXT_activeField;
	int		i, x, y, n, m;
	char		*p;
	char		s[3];
	extern	char	_EgbWk[];
	
	MOU_display(Off);
	for (i = 0; i < backLen; i++) {
		EGB_putBlock(_EgbWk, 0, backBuf[i]);
		free(backBuf[i]);
	}
	backLen = 0;
	x = CUR_X(tep);
	if (x < 0)
		x = tep -> revTop;
	y = CUR_Y(tep);
	if ((m = len) > 0 && len == pos)
		m++;
	for (i = 0; i < m; i += n) {
		n = (i < len && iskanji(*str)) ? 2 : 1;
		p = (char *)malloc(14 + FNT_X(tep) * FNT_Y(tep) * n * PIX_BYTE);
		if (p == NULL)
			break;
		DWORD(p + 0) = (unsigned int)(p + 14);
		WORD(p + 4) = getds();
		WORD(p + 6) = TOP_X(tep) + x * FNT_X(tep);
		WORD(p + 8) = TOP_Y(tep) + y * FNT_Y(tep) + 1;
		WORD(p + 10) = WORD(p + 6) + n * FNT_X(tep) - 1;
		WORD(p + 12) = WORD(p + 8) + FNT_Y(tep);
		EGB_getBlock(_EgbWk, p);
		backBuf[backLen++] = p;
		if (i < len) {
			DISP_rectangle(WORD(p + 6), WORD(p + 8), 
				WORD(p + 10), WORD(p + 12), 
				TXT_attrColor[*attr]);
			strncpy(s, str, n);
			s[n] = '\0';
			DISP_stringAt(s, 
				WORD(p + 6), WORD(p + 8) + FNT_Y(tep) - 1,
				TXT_charColor[*attr]);
			str += n;
			attr += n;
		}
		if (i == pos) {
			DISP_rectangle(WORD(p + 6), WORD(p + 12), 
				WORD(p + 10), WORD(p + 12), CUR_COL(tep));
		}
		x += n;
	}
	if(len == 0)
		MOU_display(On);
}
/* ---	OAK2_putstr()  --- */


GLOBAL	void
OAK2_putsys(
	int	len,
	char	*str,
	char	*attr)
/*
 *	PURPOSE
 *		KAN_read()ĂяoVXes\p
 *		R[obN֐
 *	IMPLEMENT
 *		(R)CMIYAZAKIɂ OAK2LIB ̃Tv𗬗pD
 */
{
	static	int	backLen = 0;
	static	char	*backBuf;
	textEntry_t	*tep = TXT_activeField;
	int		i, x, y, n;
	char		*p;
	char		s[3];
	extern	char	_EgbWk[];
	
	if (backLen > 0) {
		EGB_putBlock(_EgbWk, 0, backBuf);
		free(backBuf);
	}
	backLen = 0;
	if (len == 0)
		return;
	p = (char *)malloc(14 + FNT_X(tep) * FNT_Y(tep) * len * PIX_BYTE);
	if (p == NULL)
		return;
	backBuf = p;
	DWORD(p + 0) = (unsigned int)(p + 14);
	WORD(p + 4) = getds();
	WORD(p + 6) = x = 0;
	WORD(p + 8) = y = Mode3RealScrnY - 1 - 18;
	WORD(p + 10) = x + len * FNT_X(tep) - 1;
	WORD(p + 12) = Mode3RealScrnY - 1;
	EGB_getBlock(_EgbWk, p);
	backLen = len;
	for (i = 0; i < len; i += n) {
		n = iskanji(*str) ? 2 : 1;
		DISP_rectangle(x, y, 
				x + n * FNT_X(tep) - 1, y + FNT_Y(tep) + 2,
				TXT_attrColor[*attr]);
		strncpy(s, str, n);
		s[n] = '\0';
		DISP_stringAt(s, x, y + FNT_Y(tep) + 1, TXT_charColor[*attr]);
		str += n;
		attr += n;
		x += n * FNT_X(tep);
	}
}
/* ---	OAK2_putsys()  --- */


GLOBAL	void
OAK2_putmode(
	int	mode,
	int	shift,
	char	*str)
/*
 *	PURPOSE
 *		KAN_read()Ăяo郂[h\p
 *		R[obN֐
 *	IMPLEMENT
 *		(R)CMIYAZAKIɂ OAK2LIB ̃Tv𗬗pD
 */
{
	MOU_display(Off);
	DISP_rectangle(
		Mode3RealScrnX - 1 - 74, Mode3RealScrnY - 1 - 15, 
		Mode3RealScrnX - 1, Mode3RealScrnY - 1, CI_Gray);
	DISP_stringAt(
		str, Mode3RealScrnX - 1 - 72, Mode3RealScrnY - 1, CI_White);
	MOU_display(On);
}
/* ---	OAK2_putmode()  --- */


/*--------------------------------------*/
/*		֐`		*/
/*--------------------------------------*/

/*
	TextEntry֐QiTXT_j

	eLXg̓tB[h͈s͂̈̕łD
	TextEntry֐Q̓eLXg̓tB[hւ͂̕T|[g
	
	TXT_setDefField()p邩C邢͌ʂɐݒ肷邱Ƃɂ
	textEntry_t^ϐɓKȒlݒ肵CTXT_initField()ĂяoD
	̌L[{[h͂̕ɏ] TXT_entry() ĂяoD


	̉]̈ƂD̏ꍇ̏ԁCȉɎD
	
			  	  revTop  revEnd  cursorPos
	
	abcdef	S]	  ]u	\	  0	    6	    -1
	~~~~~~
	abcdef	]  ]u	\	  3	    5	    -1
	   ~~
	abcdef	ʏ  }/u	\	  -1	    -1	    4
	    ^
	 Ȃ		  }		\	  -1	    -1	    0

*/


GLOBAL	void
TXT_setDefField(
	textEntry_t	*p,		/* ΏۃtB[hւ̃|C^	*/
	textEntry_t	*prev,		/* OtB[hւ̃|C^	*/
	textEntry_t	*next,		/* tB[hւ̃|C^	*/
	int		luX,		/* wW			*/
	int		luY,		/* xW			*/
	int		chars,		/* tB[h͕	*/
	char		*string)	/* \ / ͌ʒm*/
/*
 *	PURPOSE
 *		1s̕WeLXg̓tB[h쐬D
 *		FCwiFCJ[\F͂ꂼꍕCDFCԐFłD
 *		OtB[h^tB[h݂ȂꍇC
 *		ꂼ prev/next  NULL w肷邱ƁD
 */
{
	p -> prev	= prev;
	p -> next	= next;
	p -> string	= string;
	TOP_X(p)	= luX + 2;
	TOP_Y(p)	= luY + 2;
	BTM_X(p)	= TOP_X(p) + chars * CharWidth;
	BTM_Y(p)	= TOP_Y(p) + CharHeight;
	CHR_COL(p)	= CI_Black;
	BAK_COL(p)	= CI_Gray;
	CUR_COL(p)	= CI_Red;
	FNT_X(p)	= CharWidth;
	FNT_Y(p)	= CharHeight;
	CUR_X(p)	= 0;
	p -> revTop	= p -> revEnd = -1;
}
/* ---	TXT_setDefField()  --- */


LOCAL	int
nbyte(
	char	*s,
	int	pos)
/*
 *	PURPOSE
 *		pos̒O̕1oCg2oCgʂD
 *	RETURNS
 *		2 : 2oCg
 *		1 : 1oCg
 *		0 : pos2oCg2oCg
 *		-1: G[(ex. pos==0)
 */
{
	int	i;
	int	bytes = 0;
	
	if (pos == 0)
		return(-1);
	for (i = 0; i < pos; i++) {
		if (iskanji(s[i])) {
			bytes = 2;
			i++;
		}
		else
			bytes = 1;
	}
	if (i != pos)
		return(0);
	return(bytes);
}
/* ---	nbyte()  --- */


LOCAL	void
cursorDisp(
	int		x,
	int		y,
	int		color,
	textEntry_t	*p)
/*
 *	PURPOSE
 *		wʒuɎwFłhr[J[\\D
 */
{
	DISP_line(x, y - FNT_Y(p) + 1, x, y, color);
}
/* ---	cursorDisp()  --- */


GLOBAL	void
TXT_showField(
	textEntry_t	*p,
	int		active)
/*
 *	PURPOSE
 *		w肳ꂽtB[hwiFŏC\D
 *		active 0 ȊOw肳ꂽꍇ́CKvɉ
 *		J[\\D
 */
{
	DISP_rectangle(TOP_X(p), TOP_Y(p), BTM_X(p), BTM_Y(p), BAK_COL(p));
	DISP_line(BTM_X(p)+1, TOP_Y(p)-2, TOP_X(p)-2, TOP_Y(p)-2, CI_Black);
	DISP_line(TOP_X(p)-2, TOP_Y(p)-2, TOP_X(p)-2, BTM_Y(p)+2, CI_Black);
	DISP_line(BTM_X(p),   TOP_Y(p)-1, TOP_X(p)-1, TOP_Y(p)-1, CI_DarkGray);
	DISP_line(TOP_X(p)-1, TOP_Y(p)-1, TOP_X(p)-1, BTM_Y(p)+1, CI_DarkGray);
	DISP_line(BTM_X(p)+2, TOP_Y(p)-2, BTM_X(p)+2, BTM_Y(p)+2, CI_White);
	DISP_line(BTM_X(p)+2, BTM_Y(p)+2, TOP_X(p)-1, BTM_Y(p)+2, CI_White);
	DISP_line(BTM_X(p)+1, TOP_Y(p)-1, BTM_X(p)+1, BTM_Y(p)+1, CI_Gray);
	DISP_line(BTM_X(p)+1, BTM_Y(p)+1, TOP_X(p),   BTM_Y(p)+1, CI_Gray);
	
	if (*p->string != '\0') {
		DISP_stringAt(p->string, 
			TOP_X(p), TOP_Y(p) + FNT_Y(p), CHR_COL(p));
		if (p->revTop >= 0) {
			DISP_xorRectangle(
				TOP_X(p) + FNT_X(p) * p->revTop, 
				TOP_Y(p), 
				TOP_X(p) + FNT_X(p) * p->revEnd - 1, 
				TOP_Y(p) + FNT_Y(p),
				CI_White);
		}
	}
	if (active) {
		if (CUR_X(p) >= 0)
			cursorDisp(TOP_X(p) + CUR_X(p) * FNT_X(p), 
					TOP_Y(p) + FNT_Y(p),
					CUR_COL(p),
					p);
	}
}
/* ---	TXT_showField() --- */


GLOBAL	textEntry_t *
TXT_getActiveField(void)
/*
 *	PURPOSE
 *		݂̃ANeButB[hʒmD
 *	RETURNS
 *		ANeButB[hւ̃|C^
 */
{
	return(TXT_activeField);
}
/* ---	TXT_getActiveField()  --- */


GLOBAL	textEntry_t *
TXT_setActiveField(
	textEntry_t	*p)
/*
 *	PURPOSE
 *		w肳ꂽtB[hANeButB[hɂD
 *		ȑÕANeButB[h̔]̈CJ[\
 *		\ƂȂD
 *		w肳ꂽtB[hɃANeBułΉȂD
 *	RETURNS
 *		w肳ꂽtB[hւ̃|C^
 *	IMPLEMENT
 *		{֐ TXT_activeField ύXD
 */
{
	textEntry_t	*pOld;
	
	if ((pOld = TXT_getActiveField()) != p) {
		if (pOld -> revTop >= 0) {
			CUR_X(pOld) = pOld -> revEnd;
			pOld -> revTop = pOld -> revEnd = -1;
		}
		TXT_showField(pOld, FALSE);
		TXT_showField(p, TRUE);
		TXT_activeField = p;
	}
	return(p);
}
/* ---	TXT_setActiveField()  --- */


LOCAL	void
textPutchar(
	textEntry_t	*p,
	int		ch)
/*
 *	PURPOSE
 *		w肳ꂽ̓tB[h1\D
 */
{
	char		s[80];
	static	int	kanji1 = 0;
	int		chars = (BTM_X(p) - TOP_X(p)) / FNT_X(p);
	int		n;
	
	if (p->revTop >= 0) {
		strncpy(s, p->string, p->revTop);
		if (kanji1) {
			s[p->revTop] = kanji1;
			s[p->revTop + 1] = ch;
			s[p->revTop + 2] = '\0';
			CUR_X(p) = p->revTop + 2;
			kanji1 = 0;
		}
		else if (iskanji(ch)) {
			kanji1 = ch;
			return;
		}
		else {
			s[p->revTop] = ch;
			s[p->revTop + 1] = '\0';
			CUR_X(p) = p->revTop + 1;
		}
		strcat(s, &p->string[p->revEnd]);
		strncpy(p->string, s, chars);
		p->string[chars] = '\0';
		p->revTop = p->revEnd = -1;
	}
	else {
		strncpy(s, p->string, CUR_X(p));
		if (kanji1) {
			s[CUR_X(p)] = kanji1;
			s[CUR_X(p) + 1] = ch;
			s[CUR_X(p) + 2] = '\0';
			n = 2;
			kanji1 = 0;
		}
		else if (iskanji(ch)) {
			kanji1 = ch;
			return;
		}
		else {
			s[CUR_X(p)] = ch;
			s[CUR_X(p) + 1] = '\0';
			n = 1;
		}
		strcat(s, &p->string[CUR_X(p)]);
		strncpy(p->string, s, chars);
		p->string[chars] = '\0';
		CUR_X(p) += n;
	}
	if (CUR_X(p) > chars)
		CUR_X(p) = chars;
	if (strlen(p->string) == chars) {
		if (nbyte(p->string, chars) == 0) {
			p->string[chars - 1] = '\0';
			if (CUR_X(p) == chars)
				CUR_X(p)--;
		}
	}
	/* \ */
	TXT_showField(p, TRUE);
}
/* ---	textPutchar()  --- */


GLOBAL	void
TXT_initField(
	textEntry_t	*top,		/* ̓tB[hQ̐擪	*/
	textEntry_t	*active)	/* ANeButB[h		*/
/*
 *	PURPOSE
 *		TextEntry֐QŎgpeϐC
 *		w肳ꂽ̓tB[hQ\D
 *		ANeButB[hɏ\w肳ĂꍇC
 *		͑̕IԂƂĕ\D
 *	IMPLEMENT
 *		{֐ TXT_activeField ύXD
 */
{
	textEntry_t	*p;
	
	TXT_charColor[0] = CI_White;
	TXT_charColor[1] = CI_White;
	TXT_charColor[2] = CI_White;
	TXT_charColor[3] = CI_White;
	TXT_charColor[4] = CI_White;
	TXT_charColor[5] = CI_White;
	TXT_charColor[6] = CI_White;
	TXT_charColor[7] = CI_White;
	TXT_attrColor[0] = CI_Black;
	TXT_attrColor[1] = CI_DarkBlue;
	TXT_attrColor[2] = CI_DarkRed;
	TXT_attrColor[3] = CI_DarkMagenta;
	TXT_attrColor[4] = CI_DarkGreen;
	TXT_attrColor[5] = CI_DarkCyan;
	TXT_attrColor[6] = CI_DarkYellow;
	TXT_attrColor[7] = CI_Gray;
	
	if (active -> string[0] == '\0') {
		active -> revTop = active -> revEnd = -1;
		CUR_X(active) = 0;
	}
	else {
		active -> revTop = 0;
		active -> revEnd = strlen(active -> string);
		CUR_X(active) = -1;
	}
	
	/* w肳ꂽeLXg̓tB[h\ */
	p = top;
	do {
		TXT_showField(p, p == active);
		p = p -> next;
	} while (p != NULL && p != top);
	
	TXT_activeField = active;
}
/* ---	TXT_initField()  --- */


GLOBAL	void
TXT_entry(
	int	ch)
/*
 *	PURPOSE
 *		ch Ŏw肳镶݂̃ANeButB[h֓͂D
 *	IMPLEMENT
 *		{֐ TXT_activeField ύXD
 */
{
	textEntry_t	*tep;
	char		s[80];
	int		x;
	
	tep = TXT_activeField;
	if (ch >= ' ' && ch <= 0xff && ch != 0x7f)
		textPutchar(tep, ch);
	else {
		switch (ch) {
		case 0x08:		/* BackSpace */
			if (tep -> revTop >= 0) {
				strcpy(s, tep->string);
				strncpy(tep->string, s, tep->revTop);
				tep->string[tep->revTop] = '\0';
				strcat(tep->string, &s[tep->revEnd]);
				CUR_X(tep) = tep->revTop;
				tep->revTop = tep->revEnd = -1;
				TXT_showField(tep, TRUE);
			}
			else if (CUR_X(tep) > 0) {
				strcpy(s, tep->string);
				strncpy(tep->string, s, CUR_X(tep));
				x = CUR_X(tep);
				if (nbyte(tep->string, CUR_X(tep)) == 2)
					CUR_X(tep)--;
				CUR_X(tep)--;
				tep->string[CUR_X(tep)] = '\0';
				strcat(tep->string, &s[x]);
				TXT_showField(tep, TRUE);
			}
			break;
		case 0x0b:		/* [HOME] */
			if (CUR_X(tep) == 0)
				CUR_X(tep) = strlen(tep->string);
			else if (CUR_X(tep) > 0)
				CUR_X(tep) = 0;
			TXT_showField(tep, TRUE);
			break;
		case 0x1c:		/* [] */
			if (CUR_X(tep) < strlen(tep->string)) {
				if (iskanji(tep->string[CUR_X(tep)]))
					CUR_X(tep)++;
				CUR_X(tep)++;
				TXT_showField(tep, TRUE);
			}
			break;
		case 0x1d:		/* [] */
			if (CUR_X(tep) > 0) {
				if (nbyte(tep->string, CUR_X(tep)) == 2)
					CUR_X(tep)--;
				CUR_X(tep)--;
				TXT_showField(tep, TRUE);
			}
			break;
		case 0x1e:		/* [] */
		case 0x8016:		/* [Os] */
			if (tep -> prev != NULL) {
				TXT_setActiveField(tep -> prev);
				tep = tep -> prev;
			}
			break;
		case 0x1f:		/* [] */
		case 0x8017:		/* [s] */
			if (tep -> next != NULL) {
				TXT_setActiveField(tep -> next);
				tep = tep -> next;
			}
			break;
		case 0x7f:		/* [폜] */
			if (tep -> revTop >= 0) {
				strcpy(s, tep->string);
				strncpy(tep->string, s, tep->revTop);
				tep->string[tep->revTop] = '\0';
				strcat(tep->string, &s[tep->revEnd]);
				CUR_X(tep) = tep->revTop;
				tep->revTop = tep->revEnd = -1;
				TXT_showField(tep, TRUE);
			}
			else if (CUR_X(tep) < strlen(tep->string)) {
				strcpy(s, tep->string);
				strncpy(tep->string, s, CUR_X(tep));
				x = CUR_X(tep);
				if (iskanji(tep->string[CUR_X(tep)]))
					x++;
				x++;
				tep->string[CUR_X(tep)] = '\0';
				strcat(tep->string, &s[x]);
				TXT_showField(tep, TRUE);
			}
			break;
		}
	}
}
/* ---	TXT_entry()  --- */


GLOBAL	int
TXT_checkCharPos(
	int		x,
	int		y,
	textEntry_t	*p)
/*
 *	PURPOSE
 *		wW(x,y)^ꂽeLXgtB[h̉
 *		ł邩ʒmD
 *	RETURNS
 *		-1	: eLXgtB[hO
 *		>= 0	: ʒui擪 0 j
 *		Ww肳ꂽtB[hłC͕̉E[
 *		Ełꍇ́CŏIʒuʒmD
 */
{
	int	n, n2, len;
	
	n = -1;
	if (TOP_X(p) <= x && x < BTM_X(p) 
			&& TOP_Y(p) <= y && y < BTM_Y(p)) {
		n = (x - TOP_X(p) + p->charWidth/2) / p->charWidth;
		len = strlen(p->string);
		n = min(n, len);
		if (nbyte(p->string, n) == 0) {
			n2 = (x - TOP_X(p)) / p->charWidth;
			if (n2 == n)
				++n;
			else
				--n;
		}
	}
	return(n);
}
/* ---	TXT_checkCharPos()  --- */


GLOBAL	int
TXT_checkCharPos2(
	int		x,
	textEntry_t	*p)
/*
 *	PURPOSE
 *		w肳ꂽwW^ꂽeLXgtB[h̉
 *		ł邩ʒmD
 *	RETURNS
 *		ʒuD
 *		A擪ʒu荶w肳ꂽꍇ́C擪ʒu
 *		ʒmD܂͍ŏIʒuEw肳ꂽꍇ́C
 *		͍ŏIʒuʒmD
 */
{
	int	n, n2, len;
	
	if (x < TOP_X(p))
		n = 0;
	else {
		n = (x - TOP_X(p) + p->charWidth/2) / p->charWidth;
		len = strlen(p->string);
		n = min(n, len);
		if (nbyte(p->string, n) == 0) {
			n2 = (x - TOP_X(p)) / p->charWidth;
			if (n2 == n)
				++n;
			else
				--n;
		}
	}
	return(n);
}
/* ---	TXT_checkCharPos2()  --- */


/*****	end of txtentry.c  *****/
