#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <egb.h>
#include <mos.h>

#define WAKU 25
#define PENSIZE 3

#define EYE_TERM 110
#define EYE_Y 120
#define EYE_X_SIZE 20
#define EYE_Y_SIZE 50

#define NOZE_Y_OVER 55
#define NOZE_Y_UNDER 25
#define NOZE_X_SIDE 35

#define MOUSE_X 160
#define MOUSE_Y 130

#define START_DEG 45
#define END_DEG (180 - START_DEG)

char	tileGray[] = { 	0xf0,0xf0,0xf0,0xf0,
						0x0f,0x0f,0x0f,0x0f } ;

char	tileBlue[] = { 	0xfd,0xfd,0xfd,0xfd,
						0xdf,0xdf,0xdf,0xdf } ;

char	work[EgbWorkSize] ;
char	mwork[MosWorkSize] ;
char	para[64] ;
void main()
{
	int		ch, dx, dy ;

	/*	OtBbN̏.		*/
	EGB_init(work,EgbWorkSize) ;
	EGB_displayPage(work,0,1) ;

	MOS_start(mwork,MosWorkSize) ;

	/*	炪C.			*/

	EGB_color(work, 1, 0xf) ;
	EGB_clearScreen(work) ;

	EGB_color(work, 0, 0) ;
	WORD(para + 0) = 320 - 40 ;
	WORD(para + 2) = 240 - 8 ;
	WORD(para + 4) = 10  ;
	strcpy(para + 6, "Hello Mac!") ;
	EGB_sjisString(work, para) ;

	EGB_writePage(work,1) ;
	EGB_clearScreen(work) ;

	/*	wi	*/

	EGB_paintMode(work, 0x40) ;
	EGB_tilePattern(work, 2, 1, 2, tileGray) ;
	WORD(para +  0) = 6 ;
	WORD(para +  2) = 0 ;
	WORD(para +  4) = 0 ;
	WORD(para +  6) = 639 ;
	WORD(para +  8) = 0 ;
	WORD(para + 10) = 639 - WAKU ;
	WORD(para + 12) = WAKU ;
	WORD(para + 14) = WAKU ;
	WORD(para + 16) = WAKU ;
	WORD(para + 18) = WAKU ;
	WORD(para + 20) = 479 - WAKU ;
	WORD(para + 22) = 0 ;
	WORD(para + 24) = 479 ;
	EGB_polygon(work, para) ;

	EGB_tilePattern(work, 2, 1, 2, tileBlue) ;
	WORD(para +  0) = WAKU ;
	WORD(para +  2) = WAKU ;
	WORD(para +  4) = 639 - WAKU ;
	WORD(para +  6) = 479 - WAKU ;
	EGB_rectangle(work, para) ;

	/*	֊s	*/

	EGB_pen(work, 0x01) ;
	EGB_penSize(work, PENSIZE) ;

	EGB_paintMode(work, 0x02) ;
	EGB_color(work, 0, 0) ;
	EGB_rectangle(work, para) ;

	/*		*/

	EGB_pen(work, 0x00) ;
	EGB_penSize(work, PENSIZE + 2) ;
	EGB_paintMode(work, 0x22) ;
	EGB_color(work, 2, 0) ;
	WORD(para +  0) =  320 - EYE_TERM ;
	WORD(para +  2) =  EYE_Y ;
	WORD(para +  4) =  320 - EYE_TERM + EYE_X_SIZE ;
	WORD(para +  6) =  EYE_Y + EYE_Y_SIZE ;
	EGB_rectangle(work, para) ;

	WORD(para +  0) =  320 + EYE_TERM - EYE_X_SIZE ;
	WORD(para +  2) =  EYE_Y ;
	WORD(para +  4) =  320 + EYE_TERM ;
	WORD(para +  6) =  EYE_Y + EYE_Y_SIZE ;
	EGB_rectangle(work, para) ;

	/*	@	*/

	EGB_penSize(work, PENSIZE - 1) ;
	WORD(para +  0) = 3 ;
	WORD(para +  2) = 320 - NOZE_X_SIDE/2 ;
	WORD(para +  4) = 240 - NOZE_Y_OVER ;
	WORD(para +  6) = 320 - NOZE_X_SIDE/2 ;
	WORD(para +  8) = 240 + NOZE_Y_UNDER ;
	WORD(para + 10) = 320 + NOZE_X_SIDE/2 ;
	WORD(para + 12) = 240 + NOZE_Y_UNDER ;
	EGB_connect(work, para) ;

	/*		*/

	EGB_penSize(work, PENSIZE ) ;
	WORD(para +  0) = 320 ;
	WORD(para +  2) = 240 ;
	WORD(para +  4) = MOUSE_X ;
	WORD(para +  6) = MOUSE_Y ;
	DWORD(para +  8) = 205887*START_DEG/180 ;
	DWORD(para + 12) = 205887*END_DEG/180 ;
	EGB_ellipticArc(work, para) ;

	EGB_displayPage(work,0,2) ;

	/*	}EX̂҂.	*/
	do {
		MOS_rdpos(&ch,&dx,&dy) ;
	} while (!ch) ;
	MOS_end() ;
}
