
		.386p			;386ی샂[h

I8259_M		equ	0000h		;master i/o adr.   (int 40h-47h)
I8259_S		equ	0010h		;slave  i/o adr.   (int 48h-4Fh)
ISR_READ	equ	0Bh		;command
EOI		equ	20h		;command (End Of Interrupt)

INT_MASK_V	equ	00001000b
INT_VECT_V	equ	4Bh		;v-sync vector number
V_INT_CLR	equ	05CAh

		public	prog_stop

		extrn	prog_start:near
		extrn	sound_init:near
		extrn	sound_off:near
		extrn	def_obj:near

		extrn	vram:near
		extrn	pmem:near
		extrn	cpoint:byte
		extrn	i_chk:byte
		extrn	i_cnt:byte
		extrn	scrolh:byte
		extrn	scrolv:byte
		extrn	scrolh2:word


CODE		segment	dword public ER use32 'CODE'
		assume	cs:CODE

		org	0000h

		cld
		call	printf
 db '\nt@~RG~[^[  V0.45  seta-SCL70144   nif-PEE00725\n'
 db '\n   for  FM snvmr             programmed by   Haruhisa Udagawa\n',0
		jmp	prog


		include	stdio.lib


disp:		mov	ah,02h
		int	21h
		ret

prog_brk:	mov	ax,4C01h
		int	21h

prog_end:	mov	ax,4C00h
		int	21h

prog:		call	parms		;p[^[h
		cmp	ds:[pon],0	;p[^̐mF
		jne	parm_ok

		call	printf
		db '\n\aG~[gt@Cw肵ĉ\n',0
		jmp	prog_brk

parm_ok:
;***********************************************
		mov	si,ds:[poi+0]	;p[^1
		mov	ebx,0
mov_lop:	lodsb
		cmp	al,0
		je	endstr
		mov	ds:[chr64+ebx],al
		mov	ds:[prog128+ebx],al
		mov	ds:[prog256+ebx],al
		inc	ebx
		jmp	mov_lop
endstr:
;*********************************************** LN^Ǎ
		mov	edx,offset chr64
		mov	ax,3D00h	;open
		int	21h
		jae	open_11

		push	dx
		call	printf
		db	'\n\ano character_file ... [\c6%s\c0]\n',0
		add	sp,2
		jmp	prog_brk

open_11:	mov	bx,ax
		mov	ecx,2000h
		mov	edx,offset vram
		mov	ah,3Fh		;read handle
		int	21h
		cmp	ax,cx
		jne	ferr		;TCYُł

;*********************************************** vOǍ
		mov	edx,offset prog128
		mov	ax,3D00h	;open
		int	21h
		jae	open_12

		mov	edx,offset prog256
		mov	ax,3D00h	;open
		int	21h
		jae	open_12

		push	dx
		call	printf
		db	'\n\ano character_file ... [\c6%s\c0]\n',0
		add	sp,2
		jmp	prog_brk

open_12:	mov	bx,ax
		mov	ecx,8000h
		mov	edx,offset pmem+8000h
		mov	ah,3Fh		;read
		int	21h
		cmp	ax,cx
		je	read_ok
		cmp	ax,4000h
		je	two_read

ferr:		call	printf
		db	'\n\at@C̓ǍɎs܂\a',0
		jmp	prog_brk

two_read:	lea	esi,pmem+8000h
		lea	edi,pmem+0C000h
		mov	ecx,4000h
		rep	movsb

read_ok:
;---------------------------------------tbs[̃ANZXv
;---------------------------------------܂ő҂Ă܂
		mov	ax,100
waitv:		mov	cx,0FFF0h
waith:		loop	waith
		dec	ax
		jne	waitv
;---------------------------------------

;---------------------------------------------------------------
;		xN^̓o^
;---------------------------------------------------------------
		cli
		push	ds
		mov	ax,cs
		mov	ds,ax
		mov	cl,INT_VECT_V	;v-sync vector number
		lea	edx,vect_v_entry
		mov	ax,2506h
		int	21h
		pop	ds

;---------------------------------------------------------------
;		^C}[݃}XN
;---------------------------------------------------------------
		in	al,I8259_M+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		or	al,00000001b
		out	I8259_M+2,al

;---------------------------------------------------------------
;		݃Cl[u
;---------------------------------------------------------------
		in	al,I8259_S+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		mov	dl,INT_MASK_V
		xor	dl,0FFh
		and	al,dl
		or	al,00100000b	;opm int mask
		out	I8259_S+2,al

		sti

;***********************************************
		call	set_pri
		call	set_crt
		call	sound_init
;***********************************************
		push	0114h	;SPRITE
		pop	fs
		call	sprite
;***********************************************
		mov	dx,0404h
		mov	al,0
		out	dx,al		; i/o mapping

		push	0034h	;LOW 1MB
		pop	gs
		mov	byte ptr gs:[0CFF82h],01100111b	;16F\

;***********************************************
		call	prog_start

;***************************************************************
;		vOI					
;***************************************************************
prog_stop:	cli
;---------------------------------------------------------------
;		^C}[݃}XN
;---------------------------------------------------------------
		in	al,I8259_M+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		and	al,11111110b
		out	I8259_M+2,al

;---------------------------------------------------------------
;		݃Cl[u
;---------------------------------------------------------------
		in	al,I8259_S+2
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		mov	dl,INT_MASK_V
		or	al,dl
		and	al,11011111b	;opm int mask
		out	I8259_S+2,al

		sti
		call	sound_off
		call	gcls
		call	set_r50

		mov	ax,4C00h
		int	21h


gcls:		push	0128h
		pop	gs
		mov	edi,0
cls_loop:	mov	dword ptr gs:[edi*4],00000000h
		inc	edi
		cmp	edi,20000h
		jne	cls_loop
		ret

;***********************************************
sprite:
;--------------------------IuWFNgy|W̏
		push	0128h		;vram
		pop	es
		mov	eax,80008000h
		mov	edi,0
elslin:		mov	es:[edi],eax
		add	edi,4
		cmp	edi,80000h
		jb	elslin
;--------------------------Agr|g̏
		mov	edi,0
obclr:		mov	dword ptr fs:[0+edi],0
		add	edi,4
		cmp	edi,10000h
		jb	obclr
;--------------------------J|e|ȕ
		mov	cx,256
		mov	edi,0
coli:		mov	word ptr fs:[2002h+edi],7FFFh	;1
		mov	word ptr fs:[2004h+edi],7FFFh	;2
		mov	word ptr fs:[2006h+edi],6	;3
		mov	word ptr fs:[2008h+edi],7FFFh	;4
		mov	word ptr fs:[200Ah+edi],10	;5
		mov	word ptr fs:[200Ch+edi],12	;6
		mov	word ptr fs:[200Eh+edi],14	;7
		mov	word ptr fs:[2010h+edi],7FFFh	;8
		mov	word ptr fs:[2012h+edi],18	;9
		mov	word ptr fs:[2014h+edi],20	;A
		mov	word ptr fs:[2016h+edi],22	;B
		mov	word ptr fs:[2018h+edi],24	;C
		mov	word ptr fs:[201Ah+edi],26	;D
		mov	word ptr fs:[201Ch+edi],7FFFh	;E
		mov	word ptr fs:[201Eh+edi],7FFFh	;F
		add	edi,20h
		dec	cx
		jne	coli
;---------------------------------------p^|f|^i[
		call	def_obj

;--------------------------IuWFNgRg|I
		mov	dx,0450h
		mov	al,0		;reg0
		out	dx,al
		mov	dx,0452h
		mov	al,0C0h
		out	dx,al
;-----
		mov	dx,0450h
		mov	al,1		;reg1
		out	dx,al
		mov	dx,0452h
		mov	al,83h
		out	dx,al
		ret


;***********************************************
set_pri:	mov	dx,0448h
		mov	al,0
		out	dx,al
		mov	dx,044Ah
		mov	al,1Dh
		out	dx,al

		mov	dx,0448h
		mov	al,1
		out	dx,al
		mov	dx,044Ah
		mov	al,09h
		out	dx,al
		ret

;***********************************************
set_crt:
		mov	esi,offset crtc
		mov	bl,00h
setlp:		mov	dx,0440h	;register select
		mov	al,bl
		out	dx,al
		mov	dx,0442h	;data set
		lodsw
		out	dx,ax
		inc	bl
		cmp	bl,20h
		jb	setlp
		ret

crtc		dw	0060h	;00 HSW1	;M
		dw	02C0h	;01 HSW2
		dw	0000h	;02 ---
		dw	0000h	;03 ---
		dw	031Fh	;04 HST
		dw	0000h	;05 VST
		dw	0004h	;06 VST2
		dw	0000h	;07 EET
		dw	0419h	;08 VST

		dw	009Ah	;09 HDS0	;̕\͈
		dw	029Ah	;10 HDE0
		dw	009Ah	;11 HDS1
		dw	029Ah	;12 HDE1

		dw	0040h	;13 VDS0 ;b.g.	;c̕\͈
		dw	0400h	;14 VDE0
		dw	0043h	;15 VDS1 ;obj
		dw	0400h	;16 VDE1

		dw	0000h	;17 FA0		;\ʒu
		dw	009Ch	;18 HAJ0
		dw	0000h	;19 FO0
		dw	0020h	;20 LO0

		dw	0000h	;21 FA1		;\ʒu
		dw	009Ch	;22 HAJ1
		dw	0000h	;23 FO1
		dw	0080h	;24 LO1

		dw	004Ah	;25 EHAJ
		dw	0001h	;26 EVAJ
		dw	1111h	;27 ZOOM

		dw	8037h	;28 CR0
		dw	0002h	;29 CR1
		dw	0000h	;30 FR
		dw	0192h	;31 CR2


set_r50:	call	set_pri_r50
		call	set_crt_r50
		call	sprite_r50
		ret

sprite_r50:	mov	dx,0450h
		mov	al,0
		out	dx,al
		mov	dx,0452h
		mov	al,0h
		out	dx,al
		mov	dx,0450h
		mov	al,1
		out	dx,al
		mov	dx,0452h
		mov	al,00h
		out	dx,al
		ret


set_pri_r50:	mov	dx,0448h
		mov	al,0
		out	dx,al
		mov	dx,044Ah
		mov	al,15h
		out	dx,al

		mov	dx,0448h
		mov	al,1
		out	dx,al
		mov	dx,044Ah
		mov	al,09h
		out	dx,al
		ret

set_crt_r50:	lea	si,crtc_r50
		mov	bl,00h
setl2:		mov	dx,0440h
		mov	al,bl
		out	dx,al
		mov	dx,0442h
		mov	ax,[si]
		add	si,2
		out	dx,ax
		inc	bl
		cmp	bl,32
		jne	setl2
		ret

crtc_r50	dw	0040h	;00 HSW1
		dw	0320h	;01 HSW2
		dw	0000h	;02 ---
		dw	0000h	;03 ---
		dw	035Fh	;04 HST
		dw	0000h	;05 VST
		dw	0010h	;06 VST2
		dw	0000h	;07 EET
		dw	036Fh	;08 VST
		dw	009Ch	;09 HDS0
		dw	031Ch	;10 HDE0
		dw	009Ch	;11 HDS1
		dw	031Ch	;12 HDE1
		dw	0040h	;13 VDS0
		dw	0360h	;14 VDE0
		dw	0040h	;15 VDS1
		dw	0360h	;16 VDE1
		dw	0000h	;17 FA0
		dw	009Ch	;18 HAJ0
		dw	0000h	;19 FO0
		dw	0050h	;20 LO0
		dw	0000h	;21 FA1
		dw	009Ch	;22 HAJ1
		dw	0000h	;23 FO1
		dw	0080h	;24 LO1 (0050h)
		dw	004Ah	;25 EHAJ
		dw	0001h	;26 EVAJ
		dw	0000h	;27 ZOOM
		dw	800Fh	;28 CR0
		dw	0003h	;29 CR1
		dw	0000h	;30 FR
		dw	0150h	;31 CR2


;---------------------------------------------------------------
;		C^vg[`
;---------------------------------------------------------------
vect_v_entry:	push	eax
		push	edx
		push	ds

		push	0014h
		pop	ds
;---------------------------------------
		mov	dx,V_INT_CLR
		mov	al,0
		out	dx,al		;v-sync v
;--------------------------------------- speed control
		cmp	word ptr ds:[i_cnt],1000
		jb	intset
		mov	word ptr ds:[i_cnt],0

		or	byte ptr ds:[pmem+2002h],80h

		test	byte ptr ds:[pmem+2000h],80h
		je	intset

		cmp	byte ptr ds:[i_chk],0	;rtis?
		jne	intset
		mov	byte ptr ds:[i_chk],1	;rtiŃNA

		mov	byte ptr ds:[cpoint],15h	;ߕύX

intset:
;--------------------------------------- XN[ʎw
		mov	al,18		;h
		mov	dx,440h
		out	dx,al

		mov	ah,byte ptr ds:[pmem+2000h]
		and	ah,01h		;scroll h bit8
		mov	al,ds:scrolh
		push	ax
		shr	ax,3
		mov	ds:[scrolh2],ax
		pop	ax

		and	ax,7
		xor	al,7
		shl	ax,1
		add	ax,8Ch		;9Ch

		mov	dx,442h
		out	dx,ax
;--------------------------------------------
		mov	al,17		;\JnAhX
		mov	dx,440h
		out	dx,al

		mov	ah,byte ptr ds:[pmem+2000h]
		and	ah,02h		;scroll v bit8
		shr	ah,1
		mov	al,ds:scrolv	;scroll v
		cmp	ax,100h
		jb	no_of
		sub	ax,10h		;100hȏȂ10h
no_of:
		mov	dx,20h	;40h	;1linẽAhX
		mul	dx
		mov	dx,ds:scrolh2
		and	dx,1Fh
		add	ax,dx

		mov	dx,442h
		out	dx,ax
;---------------------------------------
		mov	byte ptr ds:[pmem+4015h],0

		cli
		call	eoi_out

		pop	ds
		pop	edx
		pop	eax
		iretd

;---------------------------------------------------------------
;		C^vgRg[eoi𔭍s
;---------------------------------------------------------------
eoi_out:	push	ax
		mov	al,ISR_READ
		out	I8259_M,al
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		in	al,I8259_M
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		test	al,7Fh		;master ?
		jz	short eoi_slave

		mov	al,EOI
		out	I8259_M,al	;}X^[eoi𔭍s
		jmp	short eoi_exit

eoi_slave:	mov	al,EOI
		out	I8259_S,al	;Tueoi𔭍s
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2

		mov	al,ISR_READ
		out	I8259_S,al
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		in	al,I8259_S
		jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		or	al,al
		jnz	short eoi_exit

		mov	al,EOI
		out	I8259_M,al	;}X^[eoi𔭍s

eoi_exit:	jmp	short $+2
		jmp	short $+2
		jmp	short $+2
		pop	ax
		ret

CODE		ends


DATA		segment
		assume	ds:DATA

handle		dw	0000h
pwork		db	00h
pre_flag	db	00h
pon		db	00h

chr64		db	'        .C64',0
prog128		db	'        .P12',0
prog256		db	'        .P25',0

reg		db	10h dup(?)
char		db	70h dup(?)
poi		dw	10h dup(?)
buff		db	64000 dup(?)

DATA		ends
		end

