/*
    Wind Consol
*/
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    <dos.h>
#include    "defs.h"

void    CON_init()
{
    cputs("\033[2J");
}
void    CON_end()
{
    cputs("\033[2J");
}
void    cls()
{
    cputs("\033[2J");
}
void    locate(x,y)
int     x,y;
{
    cprintf("\033[%d;%dH",y+1,x+1);
}
void	color(c,rv)
int	c,rv;
{
    static int col[]={ 30,31,32,33,34,35,36,37 };

    cprintf("\033[%d;%dm",(rv == FALSE ? 0:7),col[c]);
}
void    cursol(sw)
int     sw;
{
    cprintf("\033[%dv",sw == 0 ? 1:0);
}
/********************************
void    putstr(y,str)
int     y;
char    *str;
{
    int     c;

    cprintf("\033[%d;%dH",y+1,1);
    c = 0;
    while ( *str != '\0' && *str != '\n' ) {
        if ( *str == '\t' ) {
            putch(' ');
            str++;
        } else
            putch(*(str++));
        c++;
    }
    if ( c < 80 )
	cputs("\033[0K");
}
************************************/

#define	MAX_MAC	512

static struct _MACRO {
       int      mc_ch;
       unsigned mc_ec;
    } mac_key[MAX_MAC+1];

static int	mac_cnt=0;
static int	mac_max=0;
static int	mac_flg=0;

static int      hit_flg=FALSE;
static int      ch_bak=0;
static unsigned ec_bak=0;

void	MAC_save()
{
    switch(mac_flg) {
    case 0: case 2:
	mac_flg = 1;
	mac_max = 0;
	MSG_dsp("Now KeyBord Macro Define");
	break;
    case 1:
	mac_flg = 2;
	mac_cnt = 0;
	mac_max--;
	MSG_dsp("");
	break;
    }
}
void	MAC_go()
{
    if ( mac_flg == 2 ) {
	mac_flg = 3;
	mac_cnt = 0;
	mac_key[mac_max].mc_ch = ch_bak;
	mac_key[mac_max].mc_ec = ec_bak;
    }
}
/**************************
int	KYB_read(sw,ec)
int	sw;
unsigned *ec;
{
    union REGS regs;
    int        ch;

    regs.h.ah = 0x09;
    regs.h.al = sw;
    int86(0x90,&regs,&regs);
    *ec = regs.x.bx;
    ch = regs.x.dx;
    return ch;
}
***************************/
int	KBHIT()
{
    int      ch;
    unsigned ec;

    if ( hit_flg != FALSE )
	return 1;

    if ( mac_flg == 3 ) {
	if ( mac_cnt < mac_max ) {
	    hit_flg = TRUE;
	    ch_bak = mac_key[mac_cnt].mc_ch;
	    ec_bak = mac_key[mac_cnt].mc_ec;
	    mac_cnt++;
	    return 1;
	} else {
	    mac_flg = 2;
	    mac_cnt = 0;
	    ch_bak = mac_key[mac_max].mc_ch;
	    ec_bak = mac_key[mac_max].mc_ec;
	}
    }

    for ( ; ; ) {
	ch = KYB_read(1,&ec);

	switch(ec & 0xFF00) {
	case 0x4800: case 0x4B00: case 0x4E00:
	    ch = 0xFFFF;
	    break;
	default:
	    if ( ch & 0x8000 || (ec & 0xFF00) > 0x5100 )
	        ch = 0xFFFF;
	    break;
	}

	if ( (ec & 0xFF00) == 0xFF00 ) {
	    ch_bak = ch;
	    ec_bak = ec;
	    return 0;
	}

	if ( ch != 0xFFFF || ch != ch_bak || 
	     ec != ec_bak || (ec & 0xFF00) == 0x0000 ) {
	    hit_flg = TRUE;
	    ch_bak = ch;
	    ec_bak = ec;
	    if ( mac_flg == 1 && mac_max < MAX_MAC ) {
		mac_key[mac_max].mc_ch = ch;
		mac_key[mac_max].mc_ec = ec;
		mac_max++;
	    }
	    return 1;
	}
    }
}
int	Get_key()
{
    while ( kbhit() == 0 );
    hit_flg = FALSE;
    return (ch_bak & 0xFF);
}
int	GETCH()
{
    int      ch;

    if ( (ch = Get_key()) == 0x11 ) {
	ch <<= 8;
	ch |= Get_key();
    }
    return ch;
}
