/*
    Wind Consol
*/
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    "defs.h"

void    DEL_line()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;

    cp = &(wind[act_wind]);

    if ( (n = cp->now_ptr) == ERR )
        return;
    cp->wrt_flg = TRUE;
    lp = get_lin(cp->now_ptr);

    if ( NEXT_ptr(act_wind,lp) != ERR ) {
        strcpy(undo,lp->lin);
        tp = get_lin(NEXT_ptr(act_wind,lp));
        tp->right = lp->right;
        if ( lp->right != ERR ) {
            tp = get_lin(lp->right);
            tp->left = NEXT_ptr(act_wind,lp);
        }
        cp->now_ptr = NEXT_ptr(act_wind,lp);
        xfree(n);
        cp->lin_max--;
        cp->wrt_mode = 3;

    } else if ( lp->right != ERR ) {
        lp->lin[0] = '\0';
	lp->new_flg = TRUE;
        if ( cp->wrt_mode < 2 )
            cp->wrt_mode = 2;
 
    } else {
        xfree(cp->now_ptr);
        cp->now_ptr = ERR;
        cp->lin_max = 0;
        cp->lin_pos = 0;
        cp->wrt_mode = 3;
    }
}
void    KEY_del()
{
    int     n,fg=FALSE;
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p,*s;
    char    tmp[82];

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;

    cp->wrt_flg = TRUE;
    lp = get_lin(cp->now_ptr);

    s = lp->lin;
    p = tmp;
    n = cp->cur_x;

    while ( n-- > 0 ) {
        if ( *s == '\n' || *s == '\0' )
            *(p++) = ' ';
        else if ( iskan(s) ) {
            if ( n > 0 ) {
                *(p++) = *(s++);
                *(p++) = *(s++);
                n--;
            } else
                cp->cur_x--;
         } else
            *(p++) = *(s++);
    }

    if ( iskan(s) )
        s += 2;
    else if ( *s != '\n' && *s != '\0' )
        s++;
    else
        fg = TRUE;

    while ( *s != '\0' )
        *(p++) = *(s++);

    *p = '\0';

    strcpy(lp->lin,tmp);
    lp->new_flg = TRUE;

    if ( tmp[0] == '\n' && NEXT_ptr(act_wind,lp) == ERR && lp->right == ERR )
        DEL_line();

    else if ( fg != FALSE || strchr(lp->lin,'\n') == NULL )
        WIN_merge();

    if ( cp->wrt_mode < 2 )
        cp->wrt_mode = 2;
}
void    KEY_ldel()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;

    lp = get_lin(cp->now_ptr);
    if ( cp->cur_x >= strlen(lp->lin) )
        return;

    cp->wrt_flg = TRUE;
    n = kan_pos(lp->lin,cp->cur_x);
    if ( strchr(lp->lin,'\n') == NULL ) {
        lp->lin[n] = '\0';
	lp->new_flg = TRUE;
        WIN_merge();
        cp->wrt_mode = 3;

    } else {
        lp->lin[n++] = '\n';
        lp->lin[n] = '\0';
	lp->new_flg = TRUE;
        if ( cp->wrt_mode < 2 )
            cp->wrt_mode = 2;
    }
}
void    KEY_rdel()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;

    lp = get_lin(cp->now_ptr);
    if ( cp->cur_x == 0 )
        return;

    cp->wrt_flg = TRUE;
    for ( n = 0 ; n < cp->cur_x ; ) {
        if ( lp->lin[n] == '\n' || lp->lin[n] == '\0' )
            break;
        else if ( iskan(&(lp->lin[n])) )
            n += 2;
        else
            n++;
    }

    cp->cur_x = 0;
    strcpy(lp->lin,&(lp->lin[n]));
    lp->new_flg = TRUE;
    if ( strchr(lp->lin,'\n') == NULL ) {
        WIN_merge();
        cp->wrt_mode = 3;
    } else if ( cp->wrt_mode < 2 )
        cp->wrt_mode = 2;
}
void    KEY_undo()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;
    LIN_PTR *bp;

    if ( undo[0] == '\0' )
        return;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR ) {
        cp->now_ptr = xalloc();
        lp = get_lin(cp->now_ptr);
        lp->lin[0] = '\0';
	lp->new_flg = TRUE;
        cp->lin_max = 1;
        cp->lin_pos = 0;
    }

    n = xalloc();
    tp = get_lin(n);
    strcpy(tp->lin,undo);
    tp->new_flg = TRUE;

    lp = get_lin(cp->now_ptr);
    if ( (tp->right = lp->right) != ERR ) {
        bp = get_lin(tp->right);
        bp->left = n;
    }
    lp->right = n;
    tp->left = cp->now_ptr;
    cp->now_ptr = n;

    cp->wrt_mode = 3;
    cp->lin_max++;
    cp->wrt_flg = FALSE;
}
void    KEY_bs()
{
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p;

    cp = &(wind[act_wind]);

    if ( cp->now_ptr == ERR )
        return;

    if ( --cp->cur_x < 0 ) {
        KEY_up();
        lp = get_lin(cp->now_ptr);
        cp->cur_x = 0;
        for ( p = lp->lin ; *p != '\n' && *p != '\0' ; p++ )
            cp->cur_x++;
        if ( cp->cur_x >= 80 )
            cp->cur_x = 79;
        cp->wrt_mode = 3;
    }
    KEY_del();
}
