/*
    Wind Consol
*/
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>
#include    "defs.h"

void    WIN_merge()
{
    int     n,now,nxt;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;
    char    *p,*s;
    char    tmp[162];

    cp = &(wind[act_wind]);

    if ( (now = cp->now_ptr) == ERR )
        return;

LOOP:
    lp = get_lin(now);
    if ( (nxt = NEXT_ptr(act_wind,lp)) == ERR )
        return;

    tp = get_lin(nxt);
    strcpy(tmp,lp->lin);
    for ( p = tmp ; *p != '\n' && *p != '\0' ; p++ );
    strcpy(p,tp->lin);

    if ( strlen(tmp) < 80 ) {
        strcpy(lp->lin,tmp);
	lp->new_flg = TRUE;
        lp->left = NEXT_ptr(act_wind,tp);
        if ( tp->left != ERR ) {
            tp = get_lin(tp->left);
            tp->right = now;
        }
        xfree(nxt);
        cp->lin_max--;

    } else {
        n = 0;
        s = tmp;
        p = lp->lin;
	lp->new_flg = TRUE;
        while ( n < 80 && *s != '\0' ) {
            if ( iskan(s) ) {
                if ( n == 79 )
                    break;
                *(p++) = *(s++);
                *(p++) = *(s++);
                n += 2;
            } else {
                *(p++) = *(s++);
                n++;
            }
        }
        *p = '\0';
        strcpy(tp->lin,s);
	tp->new_flg = TRUE;
        lp = tp;
        now = nxt;
    }

    cp->wrt_mode = 3;

    if ( strchr(lp->lin,'\n') == NULL )
        goto LOOP;
}

void    KEY_cr()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;
    LIN_PTR *tp;
    char    *p;

    cp = &(wind[act_wind]);

    cp->wrt_flg = TRUE;
    if ( cp->now_ptr == ERR ) {
        cp->now_ptr = xalloc();
        lp = get_lin(cp->now_ptr);
        lp->lin[0] = '\0';
	lp->new_flg = TRUE;
        cp->lin_max++;
        cp->wrt_mode = 3;
    }

    if ( cp->ins_mode == FALSE ) {
        cp->cur_x = 0;
        lp = get_lin(cp->now_ptr);
        if ( NEXT_ptr(act_wind,lp) == ERR )
            WIN_ins_line(act_wind);
        if ( WIN_down_scrool(act_wind,1) != ERR )
            cp->wrt_mode = 3;
        return;
    }

    WIN_ins_line(act_wind);
    lp = get_lin(cp->now_ptr);
    tp = get_lin(NEXT_ptr(act_wind,lp));

    p = lp->lin;
    for ( n = 0 ; n < cp->cur_x ; ) {
        if ( *p == '\n' || *p == '\0' )
            break;
        else if ( iskan(p) ) {
            if ( (n += 2) > cp->cur_x )
                break;
            p += 2;
        } else {
            p++;
            n++;
        }
    }

    if ( *p != '\n' ) {
        strcpy(tp->lin,p);
	tp->new_flg = TRUE;
        strcpy(p,"\n");
	lp->new_flg = TRUE;
    }

    cp->cur_x = 0;
    WIN_down_scrool(act_wind,1);
    lp = get_lin(cp->now_ptr);
    if ( strchr(lp->lin,'\n') == NULL )
        WIN_merge();
}
void    INS_line()
{
    WIN_ins_line(act_wind);
    WIN_down_scrool(act_wind,1);
    KEY_tline();
}
void    KEY_tab()
{
    int     i,n;
    char    tmp[32];

    n = TAB - wind[act_wind].cur_x % TAB;
    tmp[0] = '\t';
    for ( i = 1 ; i < n ; i++ )
        tmp[i] = ' ';
    tmp[i] = '\0';
    WIN_puts(act_wind,tmp);
}
void    KEY_ins_sw()
{
    WIN_PTR *cp;

    cp = &(wind[act_wind]);
    cp->ins_mode = (cp->ins_mode == FALSE ? TRUE:FALSE);
}
int     instr(str,ptn)
char    *str;
char    *ptn;
{
    int     n=0;
    char    *s;
    char    *p;

    while ( *str != '\0' ) {
        s = str;
        p = ptn;
        while ( *p != '\0' ) {
            if ( *p != *s )
                break;
            s++;
            p++;
        }
        if ( *p == '\0' )
            return n;
        str++;
        n++;
    }
    return (-1);
}

static char src_str[82];
static char rep_str[82];
static char cnv_str[82];

void    MSG_dsp(msg)
char    *msg;
{
    cprintf("\x0B\x1E%s\033[0K",msg);
}
int     KEY_serch()
{
    int     i,n,c,j;
    WIN_PTR *cp;
    LIN_PTR *lp;

    cp = &(wind[act_wind]);

    if ( src_str[0] == '\0' )
        return ERR;

    if ( (n = cp->now_ptr) == ERR )
        return;

    i = cp->cur_x;
    lp = get_lin(n);
    if ( (c = strlen(lp->lin)) < i )
        i = c;
    else if ( strncmp(&(lp->lin[i]),src_str,strlen(src_str)) == 0 )
        i++;

    c = 0;
    while ( n != ERR ) {
        lp = get_lin(n);
        if ( (j = instr(&(lp->lin[i]),src_str)) >= 0 ) {
            i += j;
            cp->now_ptr = n;
            cp->lin_pos += c;
            cp->cur_x = i;
            if ( (cp->cur_y += c) >= cp->max_y ) {
                cp->cur_y = cp->max_y / 2;
                cp->wrt_mode = 3;
            }
            return FALSE;
        }
        n = NEXT_ptr(act_wind,lp);
        c++;
        i = 0;
    }
    return TRUE;
}
void    KEY_goto()
{
    int     n;
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p;

    if ( (p = input("Goto Line ? ","")) == NULL )
        return;

    if ( (n = atoi(p)) <= 0 )
        return;

    cp = &(wind[act_wind]);

    if ( cp->lin_pos > n )
        WIN_up_scrool(act_wind,cp->lin_pos - n + 1);
    else
        WIN_down_scrool(act_wind,n - cp->lin_pos - 1);

    n = cp->max_y / 2;
    if ( cp->lin_pos >= n )
        cp->cur_y = n;
    else
        cp->cur_y = cp->lin_pos;

    cp->wrt_mode = 3;
}
void    WIN_style()
{
    int     i,ch;
    WIN_PTR *cp;

    cp = &(wind[act_wind]);

    cursol(0);
    for ( ; ; ) {
	cls();
	for ( i = 0 ; i < 25 ; i++ )
	    dsp_lin[i] = ERR;
        WIN_disp(act_wind);

        do {
            ch = getch();
            switch(ch) {
            case 0x0D:
            case 0x1B:
                goto ENDOF;
            case 0x1C:
                if ( --cp->max_y < 10 )
                    cp->max_y = 10;
                break;

            case 0x1D:
                cp->max_y++;
                if ( (cp->wind_y + cp->max_y) > 23 )
                    cp->max_y = 23 - cp->wind_y;
                break;


            case 0x1E:
                if ( --cp->wind_y < 1 )
                    cp->wind_y = 1;
                else
                    cp->max_y++;
                break;

            case 0x1F:
                if ( ++cp->wind_y > 13 )
                    cp->wind_y = 13;
                else if ( --cp->max_y < 10 ) {
                    cp->wind_y--;
                    cp->max_y++;
                }
                break;

            }
        } while ( kbhit() );
    }
ENDOF:
    WIN_all();
    WIN_disp(act_wind);
}
void    CMD_sub1()
{
    int     i,c,n,j,fg,len;
    int     ch,rp=FALSE;
    WIN_PTR *cp;
    LIN_PTR *lp;
    char    *p;
    static int  cmd=(-1);
    static char *sub1_menu[]={
        "1 Serch              ",
        "2 Replace            ",
        "3 All Replace        ",
        "4 Goto line          ",
        "5 Top of file        ",
        "6 Bottom of file     ",
        "7 System Call        ",
        "8 Window Style       ",
        NULL
    };

    if ( !menu(&cmd,10,sub1_menu) || cmd < 0 )
        return;

    switch(cmd) {
    case 0:                 /* 1 Serch          */
        cp = &(wind[act_wind]);
        if ( (n = cp->now_ptr) == ERR )
            return;
        if ( (p = input("Serch String ? ",src_str)) == NULL )
            return;
        strcpy(src_str,p);
        if ( src_str[0] == '\0' )
            return;

        fg = FALSE;
        c = 0;
        MSG_dsp("Now Serch String");
        for ( ; ; ) {
            lp = get_lin(n);
            i = 0;
            while ( (j = instr(&(lp->lin[i]),src_str)) >= 0 ) {
                i += j;
                cp->now_ptr = n;
                cp->lin_pos += c;
                c = 0;
                if ( cp->lin_pos > (cp->max_y / 2) )
                    cp->cur_y = cp->max_y / 2;
                else
                    cp->cur_y = cp->lin_pos;
                cp->cur_x = i;
                WIN_screen(act_wind);
                WIN_stat(act_wind);
                locate(cp->cur_x,cp->wind_y+cp->cur_y);
		color(6,TRUE);
                cputs(src_str);
		color(7,FALSE);
                locate(cp->cur_x,cp->wind_y+cp->cur_y);
                cursol(1);
                ch = getch();
                cursol(0);
                if ( ch == 0x0D || ch == ' ' || ch == 0x1F )
                    fg = FALSE;
                else if ( ch == 0x08 || ch == 0x1E )
                    fg = TRUE;
                else
                    goto SRCEND;
                i++;
            }
            lp = get_lin(n);
            if ( fg == FALSE ) {
                if ( NEXT_ptr(act_wind,lp) == ERR )
                    break;
                n = lp->left;
                c++;
            } else {
                if ( lp->right == ERR )
                    break;
                n = lp->right;
                c--;
            }
        }
SRCEND:
        MSG_dsp("");
        if ( cp->wrt_mode < 2 )
            cp->wrt_mode = 2;
        break;

    case 1:                 /* 2 Replace        */
        rp = TRUE;
    case 2:                 /* 3 All Replace    */
        cp = &(wind[act_wind]);
        if ( (n = cp->now_ptr) == ERR )
            return;
        if ( (p = input("Replace String ? ",rep_str)) == NULL )
            return;
        strcpy(rep_str,p);
        if ( (p = input("  Chang String ? ",cnv_str)) == NULL )
            return;
        strcpy(cnv_str,p);
        if ( rep_str[0] == '\0' )
            return;

        MSG_dsp("Now Replace String");
        fg = FALSE;
        c = 0;
        for ( ; ; ) {
            lp = get_lin(n);
            i = 0;
            while ( (j = instr(&(lp->lin[i]),rep_str)) >= 0 ) {
                i += j;
                cp->now_ptr = n;
                cp->lin_pos += c;
                c = 0;
                if ( cp->lin_pos > (cp->max_y / 2) )
                    cp->cur_y = cp->max_y / 2;
                else
                    cp->cur_y = cp->lin_pos;

                cp->cur_x = i;
                if ( rp ) {
                    WIN_screen(act_wind);
                    WIN_stat(act_wind);
                    locate(cp->cur_x,cp->wind_y+cp->cur_y);
		    color(6,TRUE);
                    cputs(rep_str);
		    color(7,FALSE);
                    locate(cp->cur_x,cp->wind_y+cp->cur_y);
                    cursol(1);
                    ch = getch();
                    cursol(0);
                } else {
                    ch = 0x0D;
                    cp->wrt_mode = 3;
                }
                if ( ch == 0x0D ) {
                    len = strlen(rep_str);
                    if ( strlen(cnv_str) == len ) {
                        strncpy(&(lp->lin[i]),cnv_str,len);
			lp->new_flg = TRUE;
                        cp->wrt_flg = TRUE;
                    } else {
                        strcpy(&(lp->lin[i]),&(lp->lin[i+len]));
                        WIN_puts(act_wind,cnv_str);
                    }
                    if ( rp )
                        WIN_flush(act_wind);
                    fg = FALSE;
                } else if ( ch == ' ' || ch == 0x1F )
                    fg = FALSE;
                else if ( ch == 0x08 || ch == 0x1E )
                    fg = TRUE;
                else
                    goto REPEND;
                i++;
            }
            lp = get_lin(n);
            if ( fg == FALSE ) {
                if ( NEXT_ptr(act_wind,lp) == ERR )
                    break;
                n = lp->left;
                c++;
            } else {
                if ( lp->right == ERR )
                    break;
                n = lp->right;
                c--;
            }
        }
REPEND:
        MSG_dsp("");
        if ( rp && cp->wrt_mode < 2 )
            cp->wrt_mode = 2;
        break;

    case 3:                 /* 4 Goto line      */
        KEY_goto();
        break;

    case 4:                 /* 5 Top of file    */
        KEY_tfile();
        break;

    case 5:                 /* 6 Bottom of file */
        KEY_bfile();
        break;

    case 6:                 /* 7 System Call    */
        CON_end();
        cursol(1);
        system("COMMAND.COM");
        cursol(0);
        CON_init();
	for ( i = 0 ; i < 25 ; i++ )
	    dsp_lin[i] = ERR;
        WIN_all();
        WIN_disp(act_wind);
        break;

    case 7:
        WIN_style();
        break;
    }
}
