vram segment byte public use32 'vram'
	assume cs:vram

;*****************************************
;  VRAM byte/word/dword access
;*****************************************

;void putVRAMb(int ofs, int byte, int seg ) 
	public putVRAMb
putVRAMb proc near
	mov fs,[esp+12]
	mov eax,[esp+8]
	mov ecx,[esp+4]
	mov fs:[ecx],al
	ret
putVRAMb endp

;void putVRAMw( int ofs, int word, int seg ) 
	public putVRAMw
putVRAMw proc near
	mov fs,[esp+12]
	mov eax,[esp+8]
	mov ecx,[esp+4]
	mov fs:[ecx],ax
	ret
putVRAMw endp

;void putVRAMd(int ofs, int dword, int seg)
	public putVRAMd
putVRAMd proc near
	mov fs,[esp+12]
	mov eax,[esp+8]
	mov ecx,[esp+4]
	mov fs:[ecx],eax
	ret
putVRAMd endp

;int getVRAMb(int ofs, int seg ) 
	public getVRAMb
getVRAMb proc near
	mov fs,[esp+8]
 	mov ecx,[esp+4]
	movzx eax,byte ptr fs:[ecx]
	ret
getVRAMb endp

;int getVRAMw(int ofs, int seg)
	public getVRAMw
getVRAMw proc near
	mov fs,[esp+8]
	mov ecx,[esp+4]
	movzx eax,word ptr fs:[ecx]
	ret
getVRAMw endp

;int getVRAMd(int ofs, int seg)
	public getVRAMd
getVRAMd proc near
	mov fs,[esp+8]
	mov ecx,[esp+4]
	mov eax,fs:[ecx]
	ret 
getVRAMd endp

vram	ends
	end

