/******************************************************************************
**
**		CDR.LIB << MSC V5.1 >>
**
**		RpC /Zp IvVK邱ƁI
**
**		PMS-DOSCD𒮂߂ɍ̂
**		ŒKvȋ@\܂BACō쐬Ă̂łB
**		܂ō̂ť̂AZuō肽ȂI
**
**		<HISTORY>
**		1990.02.21 : CREATE
**		1990.05.12 : ߰ĉ񐔂޸ޏC
**		1990.06.29 : CDR_continue()̒ǉ
**
**		Programed by Y.HIRATA Nifty-ID (NAB03321)
**
******************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>
#include	<conio.h>
#include	"cdr.h"

#define	CDR_INT	0x93

union	REGS	regs, regs ;
struct	SREGS	sregs ;

typedef struct _TRACK_INF {
	unsigned char	min ;
	unsigned char	sec ;
	unsigned char	frame ;
} TRACK_INF ;

typedef struct _TOC {
	unsigned char	cdtype;
	unsigned char	sttrack;
	unsigned char	endtrack;
	TRACK_INF	disc ;
	TRACK_INF	track[99] ;	
} TOC ;

/******************************************************************************
	CDR_cdinfo
******************************************************************************/
int CDR_cdinfo( deviceno, cdtype, starttrack, endtrack, tracktime, disktime )
int		deviceno ;			/* foCXԍ				*/
int		*cdtype ;			/* RpNgfBXN^Cv	*/
int		*starttrack ;		/* 擪gbN()ԍ		*/
int		*endtrack ;			/* ŏIgbN()ԍ		*/
char	*tracktime ;		/* gbNt		*/
char	*disktime ;			/* fBXNt		*/
{
	TOC	toc ;
	int		ret ;

	regs.h.ah = 0x54 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.x.cx = 0;
	regs.x.di = (unsigned int)&toc ;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x10 )			/* yt		*/
		ret = DEVPLY ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	*cdtype = toc.cdtype ;
	*starttrack = toc.sttrack ;
	*endtrack = toc.endtrack ;
	memcpy( tracktime,(char *)toc.track,99*3 ) ;
	memcpy( disktime,(char *)&toc.disc,3 ) ;

	return ( ret ) ;
}

/******************************************************************************
	CDR_mtplay
******************************************************************************/
int CDR_mtplay( deviceno, starttime, endtime )
int		deviceno ;			/* foCXԍ				*/
char	*starttime ;		/* tJn				*/
char	*endtime ;			/* tI				*/
{
	TRACK_INF	track_inf[2] ;
	int		ret ;

	memcpy( &track_inf[0],starttime,3 ) ;
	memcpy( &track_inf[1],endtime,3 ) ;

	regs.h.ah = 0x50 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.h.ch = 0;
	regs.h.cl = 0x01;
	regs.x.di = (unsigned int)track_inf ;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x10 )			/* yt		*/
		ret = DEVPLY ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	return ( ret ) ;
}

/******************************************************************************
	CDR_mtrplay
******************************************************************************/
int CDR_mtrplay( deviceno, starttime, endtime, count )
int		deviceno ;			/* foCXԍ				*/
char	*starttime ;		/* tJn				*/
char	*endtime ;			/* tI				*/
unsigned char count ;		/* s[g				*/
{
	TRACK_INF	track_inf[2] ;
	int		ret ;

	memcpy( &track_inf[0],starttime,3 ) ;
	memcpy( &track_inf[1],endtime,3 ) ;

	regs.h.ah = 0x50 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.h.bh = count - 1 ;
/*	ƭقł߰ĉ񐔂ďĂ̂ɁATBIOSČ-1ĂB	*/
	regs.h.ch = 0xfe;
	regs.h.cl = 0x01;
	regs.x.di = (unsigned int)track_inf ;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x10 )			/* yt		*/
		ret = DEVPLY ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	return ( ret ) ;
}

/******************************************************************************
	CDR_mphase
******************************************************************************/
int CDR_mphase( deviceno, status, nowmusicno, tracktime, disktime )
int		deviceno ;			/* foCXԍ				*/
int		*status ;			/* ỷt			*/
int		*nowmusicno ;		/* ݉t̋Ȕԍ		*/
char	*tracktime ;		/* gbNt		*/
char	*disktime ;			/* fBXNt		*/
{
	struct _status_data {
		unsigned char	res1 ;
		unsigned char	now ;
		unsigned char	res2 ;
		TRACK_INF	tracktime ;
		unsigned char	res3 ;
		TRACK_INF	disktime ;
	} status_data ;
	int		ret ;

	regs.h.ah = 0x53 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.x.cx = 0;
	regs.x.di = (unsigned int)&status_data ;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	*status = regs.h.al ;
	*nowmusicno = status_data.now ;
	memcpy( tracktime,&status_data.tracktime,3 ) ;
	memcpy( disktime,&status_data.disktime,3 ) ;

	return ( ret ) ;
}

/******************************************************************************
	CDR_pause
******************************************************************************/
int CDR_pause( deviceno )
int		deviceno ;			/* foCXԍ				*/
{
	int		ret ;

	regs.h.ah = 0x55 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.h.ch = 0;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x22 )			/* yꎞ~	*/
		ret = DEVPAUSE ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	return ( ret ) ;
}

/******************************************************************************
	CDR_continue
******************************************************************************/
int CDR_continue( deviceno )
int		deviceno ;			/* foCXԍ				*/
{
	int		ret ;

	regs.h.ah = 0x56 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.h.ch = 0;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x10 )			/* yt		*/
		ret = DEVPLY ;
	else if ( regs.h.ah == 0x23 )			/* yꎞ~ԂłȂ	*/
		ret = DEVNPAUSE ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	return ( ret ) ;
}

/******************************************************************************
	CDR_mstop
******************************************************************************/
int CDR_mstop( deviceno )
int		deviceno ;			/* foCXԍ				*/
{
	int		ret ;

	regs.h.ah = 0x52 ;
	deviceno |= 0xc0 ;
	regs.h.al = deviceno ;
	regs.h.ch = 0;

	segread( &sregs ) ;
	int86x( CDR_INT,&regs,&regs,&sregs ) ;
	ret = 0 ;								/* I			*/
	if ( regs.h.ah == 0x02 )				/* foCXԍ */
		ret = DEVERR ;
	else if ( regs.h.ah == 0x80 )			/* n[hG[		*/
		ret = regs.x.cx ;

	return ( ret ) ;
}

