/* << MSC V5.1 >> *************************************************************
**
**	GRP.LIB  for FMRذ
**
**	CREATE : 1990.09.19
**	FINISH : 1990.09.19
**
**	< NOTES >
**	TABS = 4
**
**	< HISTORY >
**	1990.09.19 : CREATE
**
**	All Rights Reserved, Copyright (C) Y.Hirata 1990.
**
**	Programed by Y.Hirata ( Nifty ID : NAB03321 )
**
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include <dos.h>
#include "grp.h"

struct videoconfig far	_v_config ;

/**************************  ̨̏ݒ  **************************/
void far GRP_init()
{
/*	ُԐݒ : ٔ\												*/
	_displaycursor( _GCURSOROFF ) ;
/*	̨̎擾														*/
	_getvideoconfig( &_v_config ) ;
/*	Ӱސݒ : װ - ̨											*/
	_setvideomode( _FMRESSCOLOR ) ;
/*	߰ނ̐ݒ : page 0											*/
	_setactivepage( 0 ) ;
/*	\߰ސݒ : page 0													*/
	_setvisualpage( 0 ) ;
/*	دߗ̈̐ݒ : XS,YS - XE,YE											*/
	_setviewport( VIEW_XS,VIEW_YS,VIEW_XE,VIEW_YE ) ;
/*	÷ĕ\̈̐ݒ : 25s 80											*/
	_settextwindow( (short)(0),(short)(0),(short)(25),(short)(80) ) ;
}

/**************************  ̨̏Iݒ  **************************/
void far GRP_end()
{
	union REGS	regs ;

/*	Ӱސݒ : װ - ̨											*/
	_setvideomode( _DEFAULTMODE ) ;
/*	߰ނ̐ݒ : page 0											*/
	_setactivepage( 0 ) ;
/*	\߰ސݒ : page 0													*/
	_setvisualpage( 0 ) ;
/*	ُԐݒ : ٕ\													*/
	_displaycursor( _GCURSORON ) ;

	regs.h.ah = 0x01 ;
	regs.h.al = 0x00 ;
	int86( 0x91,&regs,&regs ) ;
}

/******************************  گĐFݒ  ********************************/
void far GRP_palette( short color, long pixel )
/*
**	color : Fԍ
**	pixel : RGBe1޲ĂŎw(4ޯĂ̂ݗL)
*/
{
	_remappalette( color,pixel ) ;
}

/**************************  _W̐F擾  *****************************/
short far GRP_getpixel( short x, short y )
/*
**	x,y : W
*/
{
	return( _getpixel( x,y ) ) ;
}

/***************************  ߰ނ̐ݒ  ***************************/
void far GRP_writePage( short page )
{
	_setactivepage( page ) ;
}

/*****************************  \߰ނ̐ݒ  *****************************/
void far GRP_displayPage( short page )
{
	_setvisualpage( page ) ;
}

/*******************************  wiFݒ  ********************************/
void far GRP_bkcolor( long pixel )
/*
**	pixel : wiFRGBe1޲ĂŎw(4ޯĂ̂ݗL)
*/
{
	_setbkcolor( pixel ) ;
}

/*******************************  wiF擾  ********************************/
long far GRP_getbkcolor( void )
/*
**	߂l : wiF߸ْlŖ߂(RGBe1޲,4ޯĂ̂ݗL)
*/
{
	return( _getbkcolor() ) ;
}

/*******************************  `Fݒ  ********************************/
void far GRP_color( short colorno )
/*
**	colorno : Fԍ
*/
{
	_setcolor( colorno ) ;
}

/*******************************  `F擾  ********************************/
short far GRP_getcolor( void )
/*
**	߂l : ݂̕`Fԍ
*/
{
	return( _getcolor() ) ;
}

/*******************************  ̨Ͻݒ  ********************************/
void far GRP_setfillmask( unsigned char *mask )
{
	_setfillmask( mask ) ;
}

/*******************************  `ݒ  ********************************/
void far GRP_linestyle( unsigned short style )
/*
**	style : `(:0xFFFF,_:0x5555/0xAAAA,j:0xEEEE/0x7777)
*/
{
	_setlinestyle( style ) ;
}

/******************************  Ĉʒuݒ  *******************************/
void far GRP_setposion( short x, short y )
/*
**	x,y : `Jnʒu
*/
{
	_moveto( x,y ) ;
}

/***************************  _W_̐ݒ  ****************************/
void far GRP_setlogorg( short x, short y )
/*
**	x,y : _W_Ƃ镨W
*/
{
	_setlogorg( x,y ) ;
}

/****************************  دߗ̈̐ݒ  *****************************/
void far GRP_viewport( short x1, short y1, short x2, short y2 )
/*
**	x1,y1 : دߗ̈̍W(W)
**	x2,y2 : دߗ̈̉EW(W)
**
**	 {֐sA_W_ (x1,y1) ɐݒ肳B
*/
{
	_setviewport( x1,y1,x2,y2 ) ;
}

/*****************************  ̨ʸر  ******************************/
void far GRP_clearScreen( short sw )
/*
**	sw : 0-GRAPHIC, 1-TEXT, 3-GRAPHIC&TEXT
*/
{
	switch ( sw ) {
		case 0 :				/*  ̨ʂwiFœhׂ	*/
			_clearscreen( _GCLEARGRAPH ) ;
			break ;
		case 1 :				/*  ÷ĉʂwiFœhׂ		*/
			_clearscreen( _GCLEARTEXT ) ;
			break ;
		case 3 :				/*  ̨÷ĉʂwiFœhׂ	*/
		default :
			_clearscreen( _GCLEARSCREEN ) ;
	}
}

/*********************************  `  **********************************/
void far GRP_line( short x1, short y1, short x2, short y2 )
/*
**	x1,y1 : `Jnʒu
**	x2,y2 : `Iʒu
*/
{
	_moveto( x1,y1 ) ;
	_lineto( x2,y2 ) ;
}

/*********************************  _`  **********************************/
void far GRP_pset( short x, short y )
/*
**	x,y : _`ʒu
*/
{
	_moveto( x,y ) ;
	_lineto( x,y ) ;
}

/********************************  ``  *********************************/
void far GRP_rectangle( short x1, short y1, short x2, short y2, short control )
/*
**	x1,y1   : `̍W
**	x2,y2   : `̉EW
**	control : ^Ȃ΁A`hׂ UȂ΁AÊݕ`
*/
{
	if ( control )											/*  hׂ	*/
		_rectangle( _GFILLINTERIOR,x1,y1,x2,y2 ) ;
	else													/*  E	*/
		_rectangle( _GBORDER,x1,y1,x2,y2 ) ;
}

/*********************************  ʕ`  **********************************/
void far GRP_arc( short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4 )
/*
**	x1,y1   : ʂڂ钷`̍W
**	x2,y2   : ʂڂ钷`̉EW
**	x3,y3   : Jn޸(޸ق̊_́AOڂ钷`̒Sł)
**	x4,y4   : I޸(޸ق̊_́AOڂ钷`̒Sł)
**
**	 ʂ́AJn޸ق`Jn_ƂāAI޸ق܂ł𔽎v܂ɕ`
**	   ܂B
*/
{
	_arc( x1,y1,x2,y2,x3,y3,x4,y4 ) ;
}

/*********************************  ~`  **********************************/
void far GRP_circle( short x, short y, short r, short control )
/*
**	x,y     : ~̒SW
**	r       : ~̔a
**	control : ^Ȃ΁A~hׂ UȂ΁AÊݕ`
*/
{
	_moveto( x,y ) ;
	if ( control )											/*  hׂ	*/
		_ellipse( _GFILLINTERIOR,x-r,y-r,x+r,y+r ) ;
	else													/*  E	*/
		_ellipse( _GBORDER,x-r,y-r,x+r,y+r ) ;
}

/********************************  ȉ~`  *********************************/
void far GRP_ellipse( short x, short y, short rx, short ry, short control )
/*
**	x,y     : ȉ~̒SW
**	rx,ry   : ȉ~X,Ŷꂼ̔a
**	control : ^Ȃ΁Aȉ~hׂ UȂ΁AÊݕ`
*/
{
	_moveto( x,y ) ;
	if ( control )											/*  hׂ	*/
		_ellipse( _GFILLINTERIOR,x-rx,y-ry,x+rx,y+ry ) ;
	else													/*  E	*/
		_ellipse( _GBORDER,x-rx,y-ry,x+rx,y+ry ) ;
}

/********************************  ``  *********************************/
void far GRP_pie( short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, short control )
/*
**	x1,y1   : ȉ~ڂ钷`̍W
**	x2,y2   : ȉ~ڂ钷`̉EW
**	x3,y3   : Jn޸(޸ق̊_́AOڂ钷`̒Sł)
**	x4,y4   : I޸(޸ق̊_́AOڂ钷`̒Sł)
**	control : ^Ȃ΁A`hׂ UȂ΁AÊݕ`
**
**	 ʂ́AJn޸ق`Jn_ƂāAI޸ق܂ł𔽎v܂ɕ`
**	   ܂B܂Aw肳ꂽ`ɓڂȉ~̈ꕔƂȂ܂B
**	   `́Aȉ~̌ʂ̗[ƒS񂾂̂ƂȂ܂B܂Aȉ~ƒ
**	   `̒S͓łB
*/
{
	if ( control )											/*  hׂ	*/
		_pie( _GFILLINTERIOR,x1,y1,x2,y2,x3,y3,x4,y4 ) ;
	else													/*  E	*/
		_pie( _GBORDER,x1,y1,x2,y2,x3,y3,x4,y4 ) ;
}

/********************************  hׂ  *********************************/
void far GRP_paint( short x, short y, short color )
/*
**	x,y   : hׂJnW
**	color : E̐Fԍ
**
**	 JnWAE̐Fԍ܂ł̗̈`Fœhׂ܂B
*/
{
	_floodfill( x,y,color ) ;
}

/****************************  ÷ĕ\ʒu擾  *****************************/
void far GRP_gettextposition( short *row, short *column )
/*
**	row,column : ÷ĕ\ʒus/(1`)Ŏ擾܂
*/
{
	struct rccoord 	_t_position ;

	_t_position = _gettextposition() ;
	*row    = _t_position.row + 1 ;								/*  sʒu	*/
	*column = _t_position.col + 1 ;								/*  ʒu	*/
}

/****************************  ÷ĕ\ʒuݒ  *****************************/
void far GRP_locate( short row, short column )
/*
**	row,column : ÷ĕ\ʒus/(1`)Ŏw肵܂
*/
{
	short	xe, ye ;

	xe = (VIEW_XE+1) / XDOTS ;
	ye = (VIEW_YE+1) / YDOTS ;
	if ( row < 1 ) row = 1 ;
	if ( row > ye ) row = ye ;
	if ( column < 1 ) column = 1 ;
	if ( column > xe ) column = xe ;
	row -- ;
	column -- ;
	_settextposition( row,column ) ;
}

/*****************************  ÷ĕ\Fݒ  ******************************/
void far GRP_textcolor( short color )
/*
**	color : ÷Ă̐Fԍ
*/
{
	_settextcolor( color ) ;
}

/********************************  ÷ĕ\  *********************************/
void far GRP_outtext( char far *text )
{
	_outtext( text ) ;
}

/********************************  ِ  *********************************/
void far GRP_cursor( short toggle )
/*
**	toggle : ^Ȃ΁Aق\AUȂ΁A\Ƃ܂B
*/
{
	if ( toggle )
		_displaycursor( _GCURSORON ) ;
	else
		_displaycursor( _GCURSOROFF ) ;
}

/***********************  BEEPo(,w莞)  *********************/
unsigned GRP_beep( unsigned short time,unsigned short count )
/*  time  -    : 10ms P												*/
/*  count -  : {g(19200Hz) / g(Hz)						*/
{
	union	REGS	regs ;

	regs.h.ah = 0x03 ;
	regs.x.bx = time ;
	regs.x.dx = count ;

	int86( 0x9E,&regs,&regs ) ;

	return( regs.h.ah ) ;
}

