        page    60,96
;
; EPSON GT-4000/6000 SCSI-I/F Handler for High-C
;           on 80386-Native Mode
;    Copyright 1990 by S.Unozawa
;

codeseg segment dword 'CODE'
        assume  cs:codeseg
        extrn   GT_SndCmd:near
        extrn   GT_SndCnt:near
        extrn   GT_RcvCnt:near
        extrn   GT_SndPrm:near
        extrn   GT_RcvDat:near
        public  SndCmd
        public  SndCnt
        public  RcvCnt
        public  RcvDat
        public  SndPrm
        db      'GT_HC',5

;
; Send GT-3/4/6000 Command (Call by High-C)
;  Call: int SndCmd(char Code);
;
SndCmd  proc    near
        enter   0,0
        mov     ah,[ebp+8]
        call    GT_SndCmd
        leave
        ret
SndCmd  endp

; Send Control Code (Call by High-C)
;  USE : int SndCnt(char Code);
;
SndCnt  proc    near
        enter   0,0
        mov     al,[ebp+8]
        call    GT_SndCnt
        leave
        ret
SndCnt  endp

; Receive Control Code from Scanner (Call by High-C)
;  USE : char RcvCnt();
;
RcvCnt  proc    near
        call    GT_RcvCnt
        ret
RcvCnt  endp

; Send GT-3/4/6000 Parameters (Call by High-C)
;  USE : int SndPrm(char *Parm, int cnt);
;
SndPrm  proc    near
        enter   0,0
        push    edi
        push    ecx
        mov     edi,[ebp+8]
        mov     ecx,[ebp+12]
        call    GT_SndPrm
        pop     ecx
        pop     edi
        leave
        ret
SndPrm  endp

; Receive Data Block from Scanner (Call by High-C)
;  USE : int RcvDat(char *Parm, int Cnt);
;
RcvDat  proc    near
        enter   0,0
        push    edi
        push    ecx
        mov     edi,[ebp+8]
        mov     ecx,[ebp+12]
        call    GT_RcvDat
        pop     ecx
        pop     edi
        leave
        ret
RcvDat  endp
;
codeseg ends
        end
