/*	SPCONV.C		V1.0 L10	by lrǂ	*/
/*	for MS-C V5.1		1990.06.27		*/
/*	last update			1990.06.27		*/

#include <stdio.h>
#include <string.h>

unsigned char	table[]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
				21,22,23,42,25,43,24,45,26,27,28,29,30,31,32,33,34,35,36,37,
				38,39,65,40,41,89,42,46,47,48,49,50,51,52,53,54,55,56,57,90,
				58,59,61,62,63,64,66,67,68,69,70,71,72,73,74,107,75,76,77,78,
				79,80,81,82,83,84,91,85,86,108,92,87,88,93,94,95,96,97,98,99,
				100,101,102,103,104,105,106,109,110,111,
				112,113,114,115,116,117,118,119,120,121,
				122,123,124,125,126,60};

int	towns_flg;

unsigned char	conv(unsigned char c){
	int	i;
	
	if(! towns_flg){	/*	TOWNS->PC	*/
		for(i=0;i<127;i++){
			if(c==table[i])	return ((unsigned char)i);
		}
		return (c);
	}
	else{			/*	PC->TOWNS	*/
		if(c<127)	return (table[c]);
	}
	return (c);
}

abend(){
	puts("f[^߂܂Bf܂");
	exit(4);
}

int	main(int argc,char *argv[]){
	unsigned char	temp,buf[64],infile[64],outfile[64];
	int	i,j,cnt;
	FILE	*inp,*outp;
	
	if(argc != 4){
		puts("rtodq헪Q[f[^Ro[^(PC9801<-->FM-TOWNS)");
		puts("gp@FSPCONV /xx ̓t@C o̓t@C");
		puts("                 /PC w莞ɂPC9801pɕϊ܂");
		puts("                 /FM w莞ɂFM-TOWNSpɕϊ܂");
		exit (1);
	}

	puts("SPCONV		V1.0 L10	by lrǂ");
	
	towns_flg= -1;
	if(argv[1][0] == '/' || argv[1][0] == '-'){
		switch (toupper(argv[1][1])){
		  case 'F':
		  case 'T':	towns_flg=1;
		  			break;
		  case 'P':
		  case '9':	towns_flg=0;
		  			break;
		  default:	towns_flg= -1;
		  			break;
		}
	}
	
	if(towns_flg < 0){
		puts("p^̎w肪Ⴂ܂");
		exit (1);
	}
	
	strcpy(infile,argv[2]);
	if(strchr(infile,'.')==NULL){
		strcat(infile,".GDT");
	}	
	strcpy(outfile,argv[3]);	
	if(strchr(outfile,'.')==NULL){
		strcat(outfile,".GDT");
	}	

	inp=fopen(infile,"rb");
	if(! inp){
		puts("̓t@C܂");
		exit (2);
	}
	outp=fopen(outfile,"wb");
	if(! outp){
		puts("o̓t@CI[vo܂");
		fclose(inp);
		exit (3);
	}

	for(i=0;i<0x2010;i++){
		temp=fgetc(inp);
		fputc(temp,outp);
	}
	fread(buf,1,16,inp);
	cnt=fwrite(buf,1,16,outp);
	if(cnt<16)	abend();
	buf[16]=NULL;
	printf("%s  %spɕϊ܂\n",buf,towns_flg ? "FM-TOWNS":"PC9801");
	for(i=0x2020;i<0x2186;i++){
		temp=fgetc(inp);
		fputc(temp,outp);
	}

	for(i=0;i<192;i++){
		fread(buf,1,32,inp);
		buf[2]= conv(buf[2]);
		cnt=fwrite(buf,1,32,outp);
		if(cnt<32)	abend();
	}
	
	for(i=0;i<4;i++){
		fread(buf,1,20,inp);
		cnt=fwrite(buf,1,20,outp);
		if(cnt<20)	abend();
		for(j=0;j<20;j++){
			fread(buf,1,2,inp);
			buf[0]= conv(buf[0]);
			cnt=fwrite(buf,1,2,outp);
			if(cnt<2)	abend();
		}
	}
	
	fclose(inp);
	fclose(outp);
	
	return (0);
}
